<?php
/* DE/efg_firewall.inc
 *    PHP include script for efg.php,
 *    intended to show/deliver the actual firewall script
 *
 * 2014-03-29 v2.0.4 Added Braindead Google SMTP access redirection in PREROUTING chain
 * 2014-03-28 v2.0.3 Added dictionary attack prevention in INPUT Chain
 * 2014-03-27 v2.0.2 Added $MY_CIDR
 * 2014-03-22 v2.0.1 Added SYNACKANDNEW in bad_tcp_packets chain
 * 2014-03-18 v2.0.0 Released
 * 2014-02-27 v2.0.0 Started -AK
 *
 * TAB=3
 *
 * @category Net
 * @version $Id: DE/efg_firewall.inc, v2.0.4 2014-03-29
 * @author Alex KEMP http://www.modem-help.co.uk/
 *
 * (START original header)
 * Copyright 2002 Timothy Scott Morizot
 *
 * This file is part of my Easy Firewall Generator for IPTables.
 *
 * Easy Firewall Generator for IPTables is free software;
 * you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Easy Firewall Generator for IPTables is distributed
 * in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this distribution; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * (next line now set by Conteg)
 * //Set type to plain text
 * header("Content-Type: text/plain");
 * (FINISH original header)
 *
 * script transcribed to avoid use of untested '$_POST()' variables
 */

?>
#!/bin/sh
#
###############################################################################
#
# Generiert iptables Firewall-Skript für den Linux 2.4, 2.6 + Kernel später
<?php
	print "# Skript von Easy Firewall Generator für IPTables $VERSION erzeugt
# (v2.0.0 direkt auf original EFG v1.17 basiert)
# Diese Version    : copyright $YEAR_NOW Modem-Help, Ltd. ($HOME)
# Übersetzung (DE) : copyright $YEAR_NOW Modem-Help, Ltd.
# Frühere Versionen: copyright 2002 Timothy Scott Morizot (easyfwgen.morizot.net)
#
# Generierte       : $NOW
";
?>
#
# Redhat chkconfig Kommentare - Firewall vorzeitig angewendet,
#                               Spät entfernt
# chkconfig: 2345 08 92
# Beschreibung: Dieses Skript gilt oder entfernt iptables Firewall-Regeln
#
# Verwendet Einstellungen:
<?php
	print "# INET_IFACE: $INET_IFACE
#    InternetIP: ". (( $DYNAMIC_IP )
	? $DYNAMIC_IP_YES_TITLE[ $_LANG ]
	: "{$DYNAMIC_IP_NO_TITLE[$_LANG]} ($INET_ADDRESS)"
) ."
#      Computer: ". (( $GATEWAY )
	? "{$GATEWAY_YES_TITLE[$_LANG]}
#             LOCAL_IFACE: $LOCAL_IFACE
#                LOCAL_IP: $LOCAL_IP
#               LOCAL_NET: $LOCAL_NET
#             LOCAL_BCAST: $LOCAL_BCAST"
	: $GATEWAY_NO_TITLE[ $_LANG ]
) ."
#      Netzwerk: ". (( $SPECIAL_LAN )
	? (
		( $BLOCK_OUTBOUND )		? "({$BLOCK_OUTBOUND_TITLE[$_LANG]})"		: '').
		(( $INTERNAL_DHCP )		? "({$INTERNAL_DHCP_TITLE[$_LANG]})"		: '').
		(( $MANGLE_TTL )			? "({$MANGLE_TTL_TITLE[$_LANG]})"			: '').
		(( $PORT_FORWARD )		? "({$PORT_FORWARD_TITLE[$_LANG]})"			: '').
		(( $TRANSPARENT_PROXY )	? "({$TRANSPARENT_PROXY_TITLE[$_LANG]})"	: ''
	)
	: '(keiner)'
) ."
# Lassen Sie in: ". (( $INBOUND_ALLOW )
	? (
		( $SELF_IN )				? "({$SELF_NET_TITLE[$_LANG]})"				: '').
		(( $DHCP_IN )				? "({$DHCP_IN_TITLE[$_LANG]})"				: '').
		(( $DNS_IN )				? "({$DNS_IN_TITLE[$_LANG]})"					: '').
		(( $IM_IN )					? "({$IM_IN_TITLE[$_LANG]})"					: '').
		(( $HTTP_IN )				? "({$HTTP_IN_TITLE[$_LANG]})"				: '').
		(( $FTP_IN )				? "({$FTP_IN_TITLE[$_LANG]})"					: '').
		(( $EMAIL_IN )				? "({$EMAIL_IN_TITLE[$_LANG]})"				: '').
		(( $NTP_IN )				? "({$NTP_IN_TITLE[$_LANG]})"					: '').
		(( $MDNSRESPONDER_IN )	? "({$MDNSRESPONDER_IN_TITLE[$_LANG]})"	: '').
		(( $MESSENGER_IN )		? "({$MESSENGER_IN_TITLE[$_LANG]})"			: '').
		(( $NFS_IN )				? "({$NFS_IN_TITLE[$_LANG]})"					: '').
		(( $OTHER_IN )				? "({$OTHER_IN_TITLE[$_LANG]})"				: '').
		(( $SSH_IN )				? "({$SSH_IN_TITLE[$_LANG]})"					: ''
	)
	: '(keiner)'
) ."
#     Fireparse: ". (( $LOG_FIREPARSE )
	? 'Ja'
	: 'Nein'
) ."
#      IRC User: ". (( $IRC_USER )
	? 'Ja'
	: 'Nein'
) ."
#  Dict Stellen: ". (( $DICT )
	? 'Ja'
	: 'Nein'
). "\n";
?>
#
# Dieser Generator ist in erster Linie für RedHat Installationen entwickelt,
# obwohl es sich für andere anpassungsfähig sein.
#
# Es kann mit dem typischen Start ausgeführt werden und beenden Argumente.
# Wenn mit Anschlag verwendet, wird es nach dem Spülen die Firewall zu stoppen.
# Die speichern und wiederherstellen Argumente speichern oder die Regeln aus
# der Datei /etc/sysconfig/iptables. Die speichern und wieder Argumente,
# um die Kompatibilität mit Redhat oder Fedora init.d-Skript zu erhalten,
# wenn Sie es vorziehen, es zu benutzen.

# Redhat / Fedora / CentOS Installationsanweisungen
#
# 1. Lassen Sie das System-Link die iptables init.d-Startskript laufen in
#    den Zuständen 2, 3, und 5.
#    chkconfig --level 235 iptables on
#
# 2. Speichern Sie dieses Skript und führen Sie es an den Regelsatz aus dieser
#    Datei laden. Eventuell müssen Sie den Befehl dos2unix darauf ausführen,
#    um Zeilenumbrüche zu entfernen.
#
# 3. Um es beim Start angelegt wird, dieses Skript in /etc/init.d/iptables
#    kopieren. Er akzeptiert stoppen, starten, speichern und wiederherstellen
#    Argumente. (Vielleicht möchten Sie die vorhandene Erste zu speichern.)
#    Alternativ, wenn Sie die Ausgabe von 'service iptables save' Befehl die
#    init.d-Skript sollte die Regeln speichern und laden sie zur Laufzeit.
#
# 4. Für nicht Redhat-Systemen (oder Redhat Systemen, wenn Sie ein Problem haben),
#    können Sie den Befehl anzuhängen, um dieses Skript rc.local auszuführen.
#    rc.local wird typischerweise in /etc und /etc/rc.d und ist in der Regel
#    das letzte, was beim Start ausgeführt. Fügen Sie einfach
#    /path/to/script/script_name in einer eigenen Zeile in der Datei rc.local.

###############################################################################
#
# Lokale Einstellungen
#

#sysctl Lage. Wenn gesetzt, wird es sysctl verwenden, um die Kernel-Parameter
# einzustellen. Wenn diese auf die leere Zeichenfolge (oder zu löschen ist)
# eingestellt ist, ist die Verwendung von sysctl deaktiviert.

SYSCTL="/sbin/sysctl -w"

# Um den Wert direkt in der Datei /proc statt echo
# SYSCTL=""

# IPTables Location - falls anpassen

IPT="/sbin/iptables"
IPTS="/sbin/iptables-save"
IPTR="/sbin/iptables-restore"

# Internet-Schnittstelle
<?php
print "INET_IFACE=\"$INET_IFACE\"\n";
print ( $DYNAMIC_IP )
	? ''
	: "INET_ADDRESS=\"$INET_ADDRESS\"\n";
print ( $GATEWAY )
	? "
# Lokale Schnittstelleninformationen
LOCAL_IFACE=\"$LOCAL_IFACE\"
LOCAL_IP=\"$LOCAL_IP\"
LOCAL_NET=\"$LOCAL_NET\"
LOCAL_BCAST=\"$LOCAL_BCAST\"
"
	: '';
print ( $SELF_IN )
	? "
# Network Administrator Zugang
MY_CIDR=\"$SELF_NET\"
"
	: '';
?>

# Localhost-Schnittstelle

LO_IFACE="lo"
LO_IP="127.0.0.1"

# Speichern ('save') und Wiederherstellen ('restore') Argumente hier behandelt
if [ "$1" = "save" ]
then
	echo -n "Speichern Firewall /etc/sysconfig/iptables ... "
	$IPTS > /etc/sysconfig/iptables
	echo "abgemacht"
	exit 0
elif [ "$1" = "restore" ]
then
	echo -n "Wiederherstellen der Firewall /etc/sysconfig/iptables ... "
	$IPTR < /etc/sysconfig/iptables
	echo "abgemacht"
	exit 0
fi

###############################################################################
#
# Lastmodule
#

echo "Laden von Kernelmodulen ..."

# Sie sollten die folgende Zeile auskommentieren und führen Sie es zum ersten
# Mal, nur um sicherzustellen, dass alle Kernel-Modul-Abhängigkeiten sind OK.
# Es ist nicht notwendig, jedes Mal laufen, jedoch.

# /sbin/depmod -a

# Sofern Sie Kernel-Modul automatisch geladen deaktiviert, sollten Sie nicht
# brauchen, um jedes dieser Module manuell laden. Anders als ip_tables,
# ip_conntrack, und einige der optionalen Module, ich habe diese Links
# standardmäßig auskommentiert. Kommentieren Sie, wenn Sie irgendwelche
# Probleme haben oder wenn Sie behindert Modul autoload haben. Beachten Sie,
# dass einige Module müssen von einem anderen Kernel-Modul geladen werden.

# Kern netfilter-Modul
/sbin/modprobe ip_tables

# Die Stateful-Verbindung Tracking-Modul
/sbin/modprobe ip_conntrack

# Filtertabelle Modul
# /sbin/modprobe iptable_filter

# mangle-Tabelle Modul
# /sbin/modprobe iptable_mangle

# nat Tischmodul
# /sbin/modprobe iptable_nat

# LOG-Target-Modul
# /sbin/modprobe ipt_LOG

# Dies wird verwendet, um die Anzahl der Pakete pro Sekunde / min / h zu begrenzen
# /sbin/modprobe ipt_limit

# Maskerade Zielmodul
# /sbin/modprobe ipt_MASQUERADE

# Filter mit Besitzer als Teil des Spiels
# /sbin/modprobe ipt_owner

# REJECT verwirft das Paket und gibt eine ICMP-Antwort.
# Die Antwort ist konfigurierbar. Standardmäßig verweigert Verbindung.
# /sbin/modprobe ipt_REJECT

# Dieses Ziel können Pakete in der mangle-Tabelle markiert werden
# /sbin/modprobe ipt_mark

# Dieses Ziel betrifft den TCP MSS
# /sbin/modprobe ipt_tcpmss

# Dieses Spiel können mehrere Ports anstelle einer einzelnen Port oder eine Reihe
# /sbin/modprobe multiport

# Dieses Spiel Kontrollen gegen die TCP-Flags
# /sbin/modprobe ipt_state

# Dieses Spiel fängt Pakete mit ungültigen Flags
# /sbin/modprobe ipt_unclean

# Für nicht-PASV FTP-Unterstützung wird die ftp nat Modul erforderlich
<?php
	print ( $FTP_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_nat_ftp

# das Modul für die vollständige ftp connection tracking
<?php
	print ( $FTP_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_conntrack_ftp

# modulet fuld tilslutning sporenbild ftp
<?php
	print ( $IRC_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_conntrack_irc


###############################################################################
#
# Kernel Parameter Konfiguration
#
# Siehe http://ipsysctl-tutorial.frozentux.net/chunkyhtml/index.html für eine
# ausführliche Tutorial auf sysctl und den verschiedenen Einstellungen.

# Erforderlich für die IPv4-Weiterleitung zu aktivieren.
# Redhat Benutzer können versuchen Sie FORWARD_IPV4 in /etc/sysconfig/network
# auf true. Alternativ kann es in gesetzt werden /etc/sysctl.conf
<?php
	print ( $GATEWAY )
		? "if [ \"\$SYSCTL\" = \"\" ]
then
    echo \"1\" > /proc/sys/net/ipv4/ip_forward
else
    \$SYSCTL net.ipv4.ip_forward=\"1\"
fi"
		: "#if [ \"\$SYSCTL\" = \"\" ]
#then
#    echo \"1\" > /proc/sys/net/ipv4/ip_forward
#else
#    \$SYSCTL net.ipv4.ip_forward=\"1\"
#fi";
?>


# Dies ermöglicht eine dynamische Adresse Hacking.
# Dies kann helfen, wenn Sie eine dynamische IP-Adresse (zB Slip, ppp, DHCP)
# zu haben.
#if [ "$SYSCTL" = "" ]
#then
#    echo "1" > /proc/sys/net/ipv4/ip_dynaddr
#else
#    $SYSCTL net.ipv4.ip_dynaddr="1"
#fi

# Dies ermöglicht SYN-Flood-Schutz.
# Die SYN-Cookies Aktivierung kann Ihr System eine unbegrenzte Anzahl von
# TCP-Verbindungen zu akzeptieren, während immer noch versuchen, während
# eines angemessenen Service-Denial-of-Service-Angriff zu geben.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/tcp_syncookies
else
    $SYSCTL net.ipv4.tcp_syncookies="1"
fi

# Dies ermöglicht die Validierung der Quelle durch Umkehr Weg nach
# RFC1812. In anderen Worten hat das Antwortpaket von dem gleichen
# Schnittstelle, durch die das Quellenpaket gesendet wurde? Es ist
# für einfach vernetzt Systeme und Router auf Stub-Netzwerke empfohlen.
# Da das sind die Konfigurationen diese Firewall ist auf die
# Unterstützung, wende ich sie standardmäßig aktiviert. Schalten Sie
# es aus, wenn Sie mehrere Netzwerkkarten mit dem gleichen Netzwerk
# verbunden zu verwenden.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/rp_filter
else
    $SYSCTL net.ipv4.conf.all.rp_filter="1"
fi

# Diese Option ermöglicht ein Subnetz mit einer einzigen IP-Adresse die
# Firewall geschützt werden. Es wird verwendet, um eine DMZ aufzubauen.
# Da dies nicht im Fokus dieser Firewall-Skript, es ist nicht standardmäßig
# aktiviert, wird aber als Referenz enthalten.
# Siehe: http://www.sjdjweis.com/linux/proxyarp/
#if [ "$SYSCTL" = "" ]
#then
#    echo "1" > /proc/sys/net/ipv4/conf/all/proxy_arp
#else
#    $SYSCTL net.ipv4.conf.all.proxy_arp="1"
#fi

# Die folgenden Kernel-Einstellungen wurden von Alex Wochen vorgeschlagen.
# Vielen Dank!

# Dieser Kernel Parameter weist den Kernel alle ICMP-Echo-Requests an die
# Broadcast-Adresse geschickt zu ignorieren. Dies verhindert, dass eine
# Reihe von Schlümpfen und ähnliche DoS-Angriffe böse.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/icmp_echo_ignore_broadcasts
else
    $SYSCTL net.ipv4.icmp_echo_ignore_broadcasts="1"
fi

# Diese Option kann verwendet werden, zu akzeptieren oder abzulehnen Quelle
# geleitet Paketen. Es ist in der Regel standardmäßig, sondern wird allgemein
# als ein Sicherheitsrisiko. Diese Option schaltet es ab.
if [ "$SYSCTL" = "" ]
then
    echo "0" > /proc/sys/net/ipv4/conf/all/accept_source_route
else
    $SYSCTL net.ipv4.conf.all.accept_source_route="0"
fi

# Diese Option kann deaktiviert werden ICMP-Umleitungen. ICMP-Weiterleitungen
# sind in der Regel als ein Sicherheitsrisiko und sollte nicht von den meisten
# Systemen mit diesen Generator benötigt.
#if [ "$SYSCTL" = "" ]
#then
#    echo "0" > /proc/sys/net/ipv4/conf/all/accept_redirects
#else
#    $SYSCTL net.ipv4.conf.all.accept_redirects="0"
#fi

# Allerdings werden wir sicher die secure_redirects Option auf, statt.
# Diese Option nimmt nur von Gateways in der Standard-Gateways Liste.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/secure_redirects
else
    $SYSCTL net.ipv4.conf.all.secure_redirects="1"
fi

# Diese Option protokolliert Pakete von Adressen nicht möglich.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/log_martians
else
    $SYSCTL net.ipv4.conf.all.log_martians="1"
fi


###############################################################################
#
# Flush Bestehende Regeln oder Ketten
#

echo "Flushing Tabellen ..."

# Zurücksetzen Standardrichtlinien
$IPT -P INPUT ACCEPT
$IPT -P FORWARD ACCEPT
$IPT -P OUTPUT ACCEPT
$IPT -t nat -P PREROUTING ACCEPT
$IPT -t nat -P POSTROUTING ACCEPT
$IPT -t nat -P OUTPUT ACCEPT
$IPT -t mangle -P PREROUTING ACCEPT
$IPT -t mangle -P OUTPUT ACCEPT

# Spülen Sie alle Regeln
$IPT -F
$IPT -t nat -F
$IPT -t mangle -F

# Löschen Sie alle nicht-Standard-Ketten
$IPT -X
$IPT -t nat -X
$IPT -t mangle -X

if [ "$1" = "stop" ]
then
	echo "Firewall komplett gespült! Jetzt läuft ohne Firewall."
	exit 0
fi

###############################################################################
#
# Regelkonfiguration
#

###############################################################################
#
# Filter-Tabelle
#
###############################################################################

# Set Richtlinien

$IPT -P INPUT DROP
$IPT -P OUTPUT DROP
$IPT -P FORWARD DROP

###############################################################################
#
# Benutzer angegeben Ketten
#
# Benutzer Ketten, die Anzahl der Regeln jedes Paket durchqueren müssen,
# zu reduzieren.

echo "Erstellen und füllen Sie benutzerdefinierte Regelketten ..."

# Erstellen Sie eine Kette um ungültige Pakete zu filtern (INVALID)

$IPT -N bad_packets

# Erstellen Sie eine weitere Kette, schlechte TCP-Pakete filtern

$IPT -N bad_tcp_packets

# Erstellen Sie separate Ketten für ICMP, TCP (ankommend und abgehend),
# und eingehende UDP-Pakete.

$IPT -N icmp_packets

# Wird für UDP-Pakete aus dem Internet Inbound
$IPT -N udp_inbound

# Wird verwendet, um ausgehende UDP-Dienste aus dem internen Netzwerk zu blockieren
# Default, damit alle
$IPT -N udp_outbound

# Wird verwendet, um eingehende Dienste ermöglichen, wenn gewünscht
# Default nicht außer für etablierte Sitzungen
$IPT -N tcp_inbound

# Wird verwendet, um ausgehende Dienste aus internen Netzwerk zu blockieren
# Default, damit alle
$IPT -N tcp_outbound

###############################################################################
#
# Füllen Benutzer Ketten
#

###############################################################################
#
# bad_packets kette
#
<?php
	// Rules for the private network
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $GATEWAY )
		? "
# Drop-Pakete, die an die externe Schnittstelle
# behauptet eine Quelle im lokalen Netzwerk
\$IPT -A bad_packets -p ALL -i \$INET_IFACE -s \$LOCAL_NET -j LOG \
".		(( $LOG_FIREPARSE )
			? "    --log-prefix \"fp=bad_packets:2 a=DROP \""
			: "    --log-prefix \"Illegal source: \""
		). "

\$IPT -A bad_packets -p ALL -i \$INET_IFACE -s \$LOCAL_NET -j DROP
"
		: '';
?>

# Lassen INVALID Pakete sofort
$IPT -A bad_packets -p ALL -m state --state INVALID -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_packets:1 a=DROP \""
		: "    --log-prefix \"Invalid packet: \"";
?>


$IPT -A bad_packets -p ALL -m state --state INVALID -j DROP

# Dann überprüfen Sie die TCP-Pakete für zusätzliche Probleme
$IPT -A bad_packets -p tcp -j bad_tcp_packets

# Alles gut, so dass Rück
$IPT -A bad_packets -p ALL -j RETURN

###############################################################################
#
# bad_tcp_packets kette
#
# Alle TCP-Pakete wird diese Kette zu durchqueren.
# Jede neue Verbindungsversuch sollte mit einem SYN-Paket beginnen.
# Wenn nicht, ist es wahrscheinlich ein Port-Scan. Dies fällt Pakete im
# Zustand NEU, die nicht als SYN-Pakete gekennzeichnet sind.

<?php
	// If there is a gateway, exempt the internal interface.
	print ( $GATEWAY )
		? "
# Zurück zur aufrufenden Kette, wenn die fehlerhafte Pakete stammen aus
# der lokalen Schnittstelle. Dies hält die Vorgehensweise in dieser
# Firewall eines weitgehend vertrauenswürdigen internen Netzwerks.
\$IPT -A bad_tcp_packets -p tcp -i \$LOCAL_IFACE -j RETURN

# Allerdings habe ich ursprünglich diesen Filter anwenden, um die
# Weitergabe-Kette für Pakete aus dem internen Netzwerk stammt. Ich habe
# zwar nicht abschließend seine Wirkung bestimmt, scheint es um die
# interessanten Nebeneffekt der Sperrung einige der Anzeigensysteme haben.
# Offenbar einige ad-Systeme haben der Browser eine neue Verbindung
# initiieren, die nicht als ein SYN-Paket, um das Bild abzurufen Anzeige
# gekennzeichnet ist. Wenn Sie experimentieren wollen weiter kommentieren
# die obige Regel. Wenn Sie es versuchen, können Sie auch wollen, um die
# folgende Regel kommentieren. Es wird die Pakete von dem Protokollieren
# zu halten. Es gibt eine Menge von ihnen.
#\$IPT -A bad_tcp_packets -p tcp -i \$LOCAL_IFACE ! --syn -m state \\
#     --state NEW -j DROP
"
		: '';
?>

# 2014-03-22 zusätzlich -AK
# Act ehren im Namen der anderen Empfangs TCP Sequence Number
# Prediction-Angriffe (diese Angriffe verlassen sich auf die gefälschten
# Host DROP unbekannt SYN / ACK statt REJECT ihnen).
# See https://www.frozentux.net/iptables-tutorial/iptables-tutorial.html#SYNACKANDNEW
$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,ACK SYN,ACK \
    -m state --state NEW -j REJECT --reject-with tcp-reset

# Fix iptables Merkmal ermöglicht so neue Pakete mit SYN-Bit nicht gesetzt
# See https://www.frozentux.net/iptables-tutorial/iptables-tutorial.html#NEWNOTSYN
$IPT -A bad_tcp_packets -p tcp ! --syn -m state --state NEW -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:1 a=DROP \""
		: "    --log-prefix \"New not syn: \"";
?>

$IPT -A bad_tcp_packets -p tcp ! --syn -m state --state NEW -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL NONE -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:2 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL NONE -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL ALL -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:3 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL ALL -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL FIN,URG,PSH -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:4 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL FIN,URG,PSH -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:5 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,RST SYN,RST -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:6 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,RST SYN,RST -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,FIN SYN,FIN -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:7 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,FIN SYN,FIN -j DROP

# Alles gut, so dass Rück
$IPT -A bad_tcp_packets -p tcp -j RETURN

###############################################################################
#
# icmp_packets kette
#
# Diese Kette ist nur für eingehende (aus dem Internet) ICMP-Pakete.
# Type 8 (Echo Request) ist standardmäßig nicht akzeptiert. Aktivieren Sie es,
# wenn Sie wollen Remote-Hosts in der Lage, Sie zu erreichen.
# 11 (Zeitüberschreitung) ist das einzige akzeptiert, die nicht bereits durch
# die bestehende Verbindung Regel fallen würde. INPUT auf der externen
# Schnittstelle angewendet.
#
# Siehe: http://www.ee.siue.edu/~rwalden/networking/icmp.html
# für mehr Informationen über ICMP-Typen.
#
# Beachten Sie, dass die Stateful-Einstellungen ermöglichen Antworten auf
# ICMP-Pakete. Diese Regeln erlauben neue Pakete der angegebenen Typen.

# ICMP-Pakete sollten in einem Layer-2-Rahmen passen, also sollte man sie nicht
# fragmentiert werden. Fragmentierte ICMP-Pakete sind ein typisches Zeichen
# für einen Denial-of-Service-Angriff.
$IPT -A icmp_packets --fragment -p ICMP -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=icmp_packets:1 a=DROP \""
		: "    --log-prefix \"ICMP Fragment: \"";
?>

$IPT -A icmp_packets --fragment -p ICMP -j DROP

# Echo, kommentieren Sie, damit Ihr System angepingt werden.
# Entfernen Sie das Kommando LOG, wenn Sie wollen auch PING Versuche zu
# protokollieren
#
# $IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "#    --log-prefix \"fp=icmp_packets:2 a=ACCEPT \""
		: "#    --log-prefix \"Ping detected: \"";
?>

# $IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j ACCEPT

# Standardmäßig jedoch fallen Pings ohne Protokollierung. Blaster und andere
# Würmer Strahlsysteme Pings infiziert. Kommentieren Sie die Zeile unten, wenn
# Sie eingeloggt Pings wollen, aber es wird wahrscheinlich füllen Sie Ihre Logs.
$IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j DROP

# Zeitüberschreitung
$IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 11 -j ACCEPT

# Nicht angepasst, so bringen Sie es so protokolliert werden
$IPT -A icmp_packets -p ICMP -j RETURN

###############################################################################
#
# TCP & UDP
# Identify ports at:
#    http://www.chebucto.ns.ca/~rakerman/port-table.html
#    http://www.iana.org/assignments/port-numbers

###############################################################################
#
# udp_inbound kette
#
# Diese Kette beschreibt die eingehenden UDP-Pakete wird es akzeptieren.
# Es ist auf INPUT auf der Außen-oder Internet-Schnittstelle angewendet.
# Beachten Sie, dass die Stateful-Einstellungen erlauben Antworten.
# Diese Regeln sind für neue Anforderungen.
# Es fällt NetBIOS-Paketen (Windows) sofort und ohne Protokollierung.

# Lassen netbios Anrufe
# Bitte beachten Sie, dass diese Regeln nicht wirklich die Art, wie die
# Firewall-Leckereien NetBIOS-Verbindungen ändern. Verbindungen von localhost
# und interne Schnittstelle (falls vorhanden) werden standardmäßig akzeptiert.
# Antworten aus dem Internet auf Anfragen, die von oder durch die Firewall
# initiiert werden ebenfalls standardmäßig akzeptiert. Um dorthin zu gelangen,
# würden die Pakete müssen Teil einer neuen Anfrage der Internet-Schnittstelle
# empfangen werden. Sie müssten Regeln manuell hinzufügen, um diese zu
# akzeptieren. Ich habe diese Regeln, weil einige Netzwerkverbindungen,
# z. B. über Kabelmodems, neigen dazu, mit Rauschen von ungeschützten
# Windows-Maschinen gefüllt werden. Diese Regeln fallen die Pakete schnell und
# ohne Anmeldung ihnen. Dies verhindert, dass sie durchquert die gesamte Kette
# und hält das Protokoll aus, sich mit Geschwätz von Windows-Systemen überladen.
$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 137 -j DROP
$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 138 -j DROP

<?php
	// Reject ident requests. IRC User
	print ( $IRC_USER )
		? "
# IRC-Ident-Anfragen (Port 113) muss eine REJECT eher die Regel als die
# Standard-DROP-Regel haben. Dies ist die Mindestanforderung, um lange
# Wartezeiten zu vermeiden, während die Verbindung. Siehe auch die tcp_inbound
# Regel.
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 113 -j REJECT

# Eine anspruchsvollere Konfiguration könnte die Ident-Anfragen akzeptieren.
#\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 113 -j ACCEPT
".		(( $GATEWAY )
			? "
# Allerdings, wenn dies ist ein Gateway-System, das / Nats Maskeraden für die
# internen Systeme und die internen Systeme zu chatten möchten, eine einfache
# Änderung dieser Regeln ACCEPT wird nicht funktionieren. Die ident-Daemon auf
# dem Gateway müssen wissen, wie die Anfragen zu bearbeiten. Die Lager-Daemon
# in den meisten Linux-Distributionen kann das nicht tun. oidentd ist ein Paket
# das kann.
# Siehe: http://dev.ojnk.net/
"
			: ''
		)
		: '';

	// NTP server on gateway
	print ( $NTP_IN )
		? "
# Network Time Protocol (NTP) Server
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 123 -j ACCEPT
"
		: '';

	// DNS Server - TCP (most are UDP, so this could be disabled)
	print ( $DNS_IN )
		? "
# DNS-Server
# Konfigurieren Sie den Server auf Port 53 als Quellport für Anfragen verwenden.
# Anmerkung: Wenn Sie einen Caching-Only-Nameserver, der akzeptiert nur
# Anfragen aus dem privaten Netzwerk oder localhost ausführen, können Sie
# diese Zeile auskommentieren.
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 53 -j ACCEPT

# Wenn Sie nicht abfragen-Quelle nicht den Server auf Port 53 und Sie Probleme
# haben, kommentieren Sie diese Regel. Es ermöglicht insbesondere Antworten auf
# Anfragen an einen anderen Server von einem hohen UDP-Port eingeleitet.
# Die Stateful-Anschlussregeln sollten mit dieser Situation umgehen, wenn.
#\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 53 -j ACCEPT
"
		: '';

	// mDNSResponder
	print ( $MDNSRESPONDER_IN )
		? "
# mDNSResponder
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 5353 -j ACCEPT
"
		: '';

	// If running a DHCP server on the Internet interface, allow the requests
	print ( $DHCP_IN )
		? "
# Externen DHCP-Server
# Veröffentlichung DHCP-Client-Request-Pakete von externen Netzwerk Inbound
\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 68 --destination-port 67 \\
     -j ACCEPT
"
		: '';
	// If it's a dynamic address, set rule to allow inbound DHCP
	print ( $DYNAMIC_IP )
		? "
# Dynamic Address
# Wenn DHCP, ist die erste Anfrage eine Sendung. Die Antwort passt nicht genau
# das ausgehende Paket. Die folgenden explizit erlaubt den DHCP-Ports, um
# dieses Problem zu lindern. Wenn Sie Ihre dynamische Adresse erhalten durch
# ein anderes Mittel, können Sie wahrscheinlich kommentieren Sie diese Zeile.
\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 67 --destination-port 68 \\
     -j ACCEPT
"
		: '';

	// Inbound NFS selected
	print ( $NFS_IN )
		? "
# Network File System (NFS) Server
# Bitte beachten Sie, dass zusätzliche Leistungen muss, um einen NFS-Server
# durch die Firewall konfiguriert werden, unterstützt. Lesen Sie die Hilfe
# im Generator oder dieser Site:
# http://www.lowth.com/LinWiz/nfs_help.html

# NFS Server - portmapper
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 111 -j ACCEPT

# NFS Server - statd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $STATD_PORT -j ACCEPT

# NFS Server - NFS daemon
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 2049 -j ACCEPT

# NFS Server - lockd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $LOCKD_PORT -j ACCEPT

# NFS Server - mountd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $MOUNTD_PORT -j ACCEPT

# NFS Server - quotad
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $RQUOTAD_PORT -j ACCEPT
"
		: '';

	// User specified inbound rule
	print ( $OTHER_IN and $OTHER_IN_UDP )
		? "
# Benutzer angegebene erlaubt UDP-Protokoll
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $OTHER_IN_FROM".
(( empty( $OTHER_IN_TO )) ? '' : ":$OTHER_IN_TO")." -j ACCEPT
"
		: '';
?>

# Nicht abgestimmt, so dass für die Anmeldung zurück
$IPT -A udp_inbound -p UDP -j RETURN

###############################################################################
#
# udp_outbound kette
#
# Diese Kette wird mit einem privaten Netzwerk verwendet werden, um
# Weiterleitung für UDP-Anfragen auf bestimmte Protokolle zu verhindern.
# Auf die FORWARD-Regel aus dem internen Netz. Endet mit einem ACCEPT

<?php
	// If IM blocked, block ICQ, which uses UDP 4000
	print ( $IM_OUT )
		? "
# ICQ verwendet UDP 4000 - Instant Messaging blockiert
\$IPT -A udp_outbound -p UDP -s 0/0 --destination-port 4000 -j REJECT
"
		: '';
?>

# Kein Spiel, so ACCEPT
$IPT -A udp_outbound -p UDP -s 0/0 -j ACCEPT

###############################################################################
#
# tcp_inbound kette
#
# Diese Kette wird verwendet, um eingehende Verbindungen zu dem System / Gateway
# zu ermöglichen. Mit Vorsicht verwenden. Der Standardwert ist NONE. Es ist auf
# INPUT von der externen / Internet Schnittstelle angewendet.

<?php
	// allow own IP/CIDR through
print ( $SELF_IN )
	? "
# Lassen Sie sich durch (eine statische IP / CIDR ist am besten)
# Um die zulässige einzugrenzen, entfernen Sie diese Regel und kommentieren die
# INPUT-Regel (Dann hinzufügen oder löschen Ports nach Bedarf)
#\$IPT -A tcp_inbound -p TCP -s \$MY_CIDR -m multiport --destination-ports 21,22 -j ACCEPT
"
	: '';

	// Reject ident requests. IRC User
	print ( $IRC_USER )
		? "
# IRC-Ident-Anfragen (Port 113) muss eine REJECT eher die Regel als die
# Standard-DROP-Regel haben. Dies ist die Mindestanforderung, um lange
# Wartezeiten zu vermeiden, während die Verbindung. Siehe auch die udp_inbound Regel.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 113 -j REJECT

# Eine anspruchsvollere Konfiguration könnte die Ident-Anfragen akzeptieren.
#\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 113 -j ACCEPT
".		(( $GATEWAY )
			? "
# Allerdings, wenn dies ist ein Gateway-System, das / Nats Maskeraden für die
# internen Systeme und die internen Systeme zu chatten möchten, eine einfache
# Änderung dieser Regeln ACCEPT wird nicht funktionieren. Die ident-Daemon auf
# dem Gateway müssen wissen, wie die Anfragen zu bearbeiten. Die Lager-Daemon
# in den meisten Linux-Distributionen kann das nicht tun. oidentd ist ein Paket
# das kann.
# Siehe: http://dev.ojnk.net/
"
			: ''
		)
		: '';

//DNS Server - TCP (most are UDP, so this could be disabled)
	print ( $DNS_IN )
		? "
# DNS-Server - Erlaube TCP-Verbindungen (Zonentransfers und große Anfragen)
# Dies ist standardmäßig deaktiviert. DNS-Zonenübertragungen werden über TCP.
# Wenn Sie Überweisungen über das Netz Sie diese Zeile auskommentieren müssen
# ermöglichen. Wenn Sie Abfragen aus dem 'Netz zu ermöglichen, müssen Sie auch
# bewusst, dass, obwohl DNS-Abfragen verwenden UDP standardmäßig eine verkürzte
# UDP-Abfrage kann rechtlich über TCP statt eingereicht werden können. Sie
# werden wahrscheinlich nie brauchen, aber sollte sich der Tatsache bewusst sein.
# \$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 53 -j ACCEPT
"
		: '';

	// mDNSResponder
	print ( $MDNSRESPONDER_IN )
		? "
# mDNSResponder
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 5353 -j ACCEPT
"
		: '';

	// HTTP
	print ( $HTTP_IN )
		? "
# HTTP-Web-Server
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 80 -j ACCEPT
"
		: '';

	// HTTPS
	print ( $HTTPSSL_IN )
		? "
# HTTPS (Secure Web Server)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 443 -j ACCEPT
"
		: '';

	if( $FTP_IN ) {
		// FTP
		print "
# FTP-Server (Control)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 21 -j ACCEPT

# FTP-Client (Datenanschluss für nicht-PASV-Übertragungen)
\$IPT -A tcp_inbound -p TCP -s 0/0 --source-port 20 -j ACCEPT

# Passives FTP
#
# Bei passiven FTP, stellt der Server einen Port auf dem Client und ermöglicht
# dem Kunden, um die Verbindung eher als Einleitung der Verbindung mit dem
# Client vom Datenport zu initiieren. Web-Browser und Betriebs Clients hinter
# einer Firewall verwenden in der Regel passive FTP-Transfers. Ein
# Allzweck-FTP-Server benötigen, um sie zu unterstützen.
#
# Jedoch standardmäßig ein FTP-Server einen Port aus dem gesamten Bereich der
# hohen Ports auswählen. Es ist nicht besonders sicher, um alle hohen Ports zu
# öffnen. Glücklicherweise kann dieser Bereich begrenzt werden. Diese Firewall
# setzt voraus, dass der Bereich auf einen bestimmten Bereich ausgewählt wurde
# eingeschränkt. Dieser Bereich muss auch im FTP-Server konfiguriert werden.
#
# Anleitung für die Angabe der Port-Bereich für die wu-ftpd-Server finden
# Sie hier:
# http://www.wu-ftpd.org/man/ftpaccess.html
# (Siehe die Möglichkeit, passive Ports.)
#
# Anweisungen für den ProFTPD-Server finden Sie hier:
# http://proftpd.linux.co.uk/localsite/Userguide/linked/x861.html
";

		// Passive FTP
		print ( $PASSIVE_IN )
			? "
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $PASSIVE_PORT_FROM:$PASSIVE_PORT_TO -j ACCEPT
"
			: "
# Probe-Regel
# \$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 62000:64000 -j ACCEPT
";
	}

	// Email
	print ( $EMAIL_IN )
		? "
# E-Mail-Server (SMTP)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 25 -j ACCEPT

# E-Mail-Server (POP3)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 110 -j ACCEPT

# E-Mail-Server (IMAP4)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 143 -j ACCEPT
"
		: '';

	print ( $EMAILSSL_IN )
		? "
# SSL E-Mail-Server (POP3)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 995 -j ACCEPT

# SSL E-Mail-Server (IMAP4)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 993 -j ACCEPT
"
		: '';

	// SSH
	print ( $SSH_IN )
		? "
# SSH
# MH-Hilfe: wie geliefert, ermöglicht die nächste Zeile ssh-Verbindungen aus
# einer beliebigen Quelle ('-s 0/0). Das wird auf Hunderte von täglichen
# Verbindungen von IPs versucht Wörterbuch-Attacken auf Ihrem Gerät führen.
# Wenn möglich, werden Sie dringend empfohlen, die eigene IP / CIDR dort statt
# platzieren: z. B. '-s \$MY_IP' oder '-s \$MY_CIDR'.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 22 -j ACCEPT
"
		: '';

	// ICQ
	print ( $IM_IN )
		? "
# ICQ Datei-Transfers und andere erweiterte Funktionen
#
# ICQ unterstützt eine Reihe von Optionen, die über einfache Instant Messaging.
# Für diejenigen, die zu funktionieren, muss die Instant-Messaging-System neue
# Verbindungen von entfernten Systemen initiiert ermöglichen. Diese Option
# wird einen bestimmten Port-Bereich auf dem Firewall-System zu öffnen. Der
# ICQ-Client auf dem Firewall-System muss auch so konfiguriert werden, um die
# angegebene Port-Bereich zu nutzen.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $IM_PORT_FROM:$IM_PORT_TO -j ACCEPT
"
		: '';

	// MSN Messenger
	print ( $MESSENGER_IN )
		? "
# MSN Messenger File Transfers
#
# Messenger unterstützt Dateiübertragungen. Für Überweisungen von
# Remote-Systemen zu funktionieren eingeleitet, muss das System neue
# Verbindungen von entfernten Systemen eine bestimmte Port-Bereich initiiert
# ermöglichen. Diese Option wird standardmäßig der Port-Bereich 6891 bis 6900.
# Es sei denn, die MSN Messenger-Client kann so konfiguriert werden, um
# Port-Bereich angeben, wird der Standard nicht zu ändern.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $MSN_PORT_FROM:$MSN_PORT_TO -j ACCEPT
"
		: '';

	// Inbound NFS selected
	print ( $NFS_IN )
		? "
# Network File System (NFS) Server
#
# Bitte beachten Sie, dass zusätzliche Leistungen muss, um einen NFS-Server
# durch die Firewall konfiguriert werden, unterstützt. Lesen Sie die Hilfe
# im Generator oder dieser Site:
# http://www.lowth.com/LinWiz/nfs_help.html

# NFS Server - portmapper
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 111 -j ACCEPT

# NFS Server - statd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $STATD_PORT -j ACCEPT

# NFS Server - NFS daemon
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 2049 -j ACCEPT

# NFS Server - lockd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $LOCKD_PORT -j ACCEPT

# NFS Server - mountd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $MOUNTD_PORT -j ACCEPT

# NFS Server - quotad
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $RQUOTAD_PORT -j ACCEPT
"
		: '';

	// User specified inbound rule
	print ( $OTHER_IN and $OTHER_IN_TCP )
		? "
# Benutzer angegebene erlaubt TCP-Protokoll
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port  $OTHER_IN_FROM".
(( empty( $OTHER_IN_TO )) ? '' : ":$OTHER_IN_TO")." -j ACCEPT
"
		: '';
?>

# Nicht angepasst, so bringen Sie es so protokolliert werden
$IPT -A tcp_inbound -p TCP -j RETURN

###############################################################################
#
# tcp_outbound kette
#
# Diese Kette wird mit einem privaten Netzwerk verwendet werden, um
# Weiterleitung für Anfragen auf bestimmte Protokolle zu verhindern. Auf die
# FORWARD-Regel aus dem internen Netz. Endet mit einem ACCEPT

<?php
	// IRC
	print ( $IRC_OUT )
		? "
# Blockieren IRC
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 194 -j REJECT
"
		: '';

	// telnet
	print ( $TELNET_OUT )
		? "
# Blockieren Outbound Telnet
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 23 -j REJECT
"
		: '';

	// ssh
	print ( $SSH_OUT )
		? "
# Blockieren SSH
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 22 -j REJECT
"
		: '';

	// usenet
	print ( $NEWS_OUT )
		? "
# Blockieren Usenet Access
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 119 -j REJECT
"
		: '';

	// web
	print ( $HTTP_OUT )
		? "
# Blockieren Web Access
# HTTP
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 80 -j REJECT

# HTTPS (Secure Web)
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 443 -j REJECT
"
		: '';

	// ftp
	print ( $FTP_OUT )
		? "
# Blockieren FTP Access
# Control
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 21 -j REJECT

# Data
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 20 -j REJECT
"
		: '';

	// Instant Messaging
	print ( $IM_OUT )
		? "
# Blockieren Instant Messaging
# AIM
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 5190 -j REJECT

# AIM Images
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 4443 -j REJECT

# MSN Messenger
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 1863 -j REJECT
"
		: '';

	// Instant Messaging
	print ( $EMAIL_OUT )
		? "
# Blockieren Sie E-Mail-Zugriff auf externe Server
# SMTP
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 25 -j REJECT

# POP3
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 110 -j REJECT

# IMAP4
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 143 -j REJECT
"
		: '';
?>

# Kein Spiel, so ACCEPT
$IPT -A tcp_outbound -p TCP -s 0/0 -j ACCEPT

###############################################################################
#
# INPUT Kette
#

echo "Prozess INPUT-Kette ..."

# Lassen Sie alle auf localhost-Schnittstelle
$IPT -A INPUT -p ALL -i $LO_IFACE -j ACCEPT

# Lassen fehlerhafte Pakete
$IPT -A INPUT -p ALL -j bad_packets

# DOCSIS Kabelmodems
# Einige DOCSIS Kabelmodems senden IGMP Multicast an Computer zu finden. Die
# Multicast-Pakete haben die Ziel-Adresse 224.0.0.1. Sie können sie zu
# akzeptieren. Wenn Sie sich dafür entscheiden, kommentieren Sie die Regel, sie
# zu akzeptieren und kommentieren die Regel, um sie fallen zu lassen Die
# Firewall wird sie hier fallen standardmäßig nicht zu überfrachten Sie das
# Protokoll. Die Firewall wird alle Multicasts auf das gesamte Teilnetz
# (224.0.0.1) standardmäßig sinken. Um nur auf IGMP Multicast, ändern '-p ALL'
# in '-p 2'. Natürlich, wenn sie nicht an anderer Stelle akzeptiert, wird es
# nur dafür sorgen, dass Multicasts auf andere Protokolle angemeldet sind.
# Lassen Sie sie ohne Protokollierung.
$IPT -A INPUT -p ALL -d 224.0.0.1 -j DROP
# Die Regel, die Pakete anzunehmen.
# $IPT -A INPUT -p ALL -d 224.0.0.1 -j ACCEPT

<?php
	if( $GATEWAY ) {
		// Rules for the private network
		print "
# Lassen DHCP-Client-Request-Pakete aus dem internen Netzwerk Inbound
\$IPT -A INPUT -p ALL -i \$LOCAL_IFACE -s \$LOCAL_NET -j ACCEPT
\$IPT -A INPUT -p ALL -i \$LOCAL_IFACE -d \$LOCAL_BCAST -j ACCEPT
";

		// If running DHCP internally from this server, also allow dhcp client requests
		print ( $INTERNAL_DHCP )
			? "
# Lassen DHCP-Client-Request-Pakete aus dem internen Netzwerk Inbound
\$IPT -A INPUT -p UDP -i \$LOCAL_IFACE --source-port 68 --destination-port 67 \\
     -j ACCEPT
"
			: '';
	}
?>

# Inbound Internet Packet-Regeln

# Akzeptieren Gegründet Anschlüsse
$IPT -A INPUT -p ALL -i $INET_IFACE -m state --state ESTABLISHED,RELATED \
     -j ACCEPT

<?php
	// allow own IP/CIDR through
print ( $SELF_IN )
	? "
# Lassen Sie sich durch (eine statische IP / CIDR ist am besten)
# Wie geliefert, diese Regel erlaubt den Zugriff auf alle Ports \$MY_CIDR
# Um die zulässige einzugrenzen, kommentieren diese Regel und kommentieren
# Sie die tcp_inbound Regel
\$IPT -A INPUT -p TCP -s \$MY_CIDR   -j ACCEPT
"
	: '';

print ( $DICT )
	? "
# Stoppen Wörterbuch-Angriffe:
# Dies stoppt NEW Verbindungsraten von mehr als 3/minute pro IP
# (Zusätzlich, dann benötigt eine ruhige Zeit 60 Sek.)
# Die verwendeten Ports müssen identisch sein, in allen 4 Zeilen unter
# See: https://www.frozentux.net/iptables-tutorial/iptables-tutorial.html#RECENTMATCH
# See: http://forums.modem-help.co.uk/viewtopic.php?t=11438
\$IPT -A INPUT -p TCP -m tcp -m multiport --destination-ports 20,21,25,110,143 \
     -m state --state NEW -m recent --update \
     --seconds 60 --hitcount 4 --rttl -j DROP
\$IPT -A INPUT -p TCP -m tcp -m multiport --destination-ports 20,21,25,110,143 \
     -m state --state NEW -m recent --update \
     --seconds 60 --hitcount 3 --rttl -j LOG \
    --log-prefix \"Dictionary attack: \"
\$IPT -A INPUT -p TCP -m tcp -m multiport --destination-ports 20,21,25,110,143 \
     -m state --state NEW -m recent --update \
     --seconds 60 --hitcount 3 --rttl -j DROP
\$IPT -A INPUT -p TCP -m tcp -m multiport --destination-ports 20,21,25,110,143 \
     -m state --state NEW -m recent --set
"
	: '';
?>

# Route der Rest auf die entsprechende Benutzerkette
$IPT -A INPUT -p TCP -i $INET_IFACE -j tcp_inbound
$IPT -A INPUT -p UDP -i $INET_IFACE -j udp_inbound
$IPT -A INPUT -p ICMP -i $INET_IFACE -j icmp_packets

# Lassen Sie ohne Anmeldung Sendungen, die so weit zu kommen.
# Verkürzt sich auf Protokoll Unordnung. Kommentieren Sie diese Zeile, wenn die
# Erprobung neuer Regeln, die Auswirkungen Broadcast-Protokolle.
$IPT -A INPUT -m pkttype --pkt-type broadcast -j DROP

# Melden Sie sich Pakete, die noch nicht übereinstimmen
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "
\$IPT -A INPUT -j LOG --log-prefix \"fp=INPUT:99 a=DROP \"
"
		: "
\$IPT -A INPUT -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"INPUT packet died: \"
";
?>

###############################################################################
#
# FORWARD Kette
#

echo "Prozess FORWARD-Kette ... "

# Wird verwendet, wenn Weiterleitung für ein privates Netzwerk

<?php
	if( $GATEWAY ) {
		// private network exists
		print "
# Lassen fehlerhafte Pakete
\$IPT -A FORWARD -p ALL -j bad_packets

# Akzeptieren TCP Pakete, die wir aus internen Quellen weiterleiten möchten
\$IPT -A FORWARD -p tcp -i \$LOCAL_IFACE -j tcp_outbound

# Akzeptieren UDP Pakete, die wir aus internen Quellen weiterleiten möchten
\$IPT -A FORWARD -p udp -i \$LOCAL_IFACE -j udp_outbound

# Wenn nicht blockiert, nehmen alle anderen Pakete von der internen Schnittstelle
\$IPT -A FORWARD -p ALL -i \$LOCAL_IFACE -j ACCEPT

# Deal mit Antworten aus dem Internet
\$IPT -A FORWARD -i \$INET_IFACE -m state --state ESTABLISHED,RELATED \\
     -j ACCEPT

";

		// If port forwarding option selected, the forward chain must also
		// accept the port forwarding.
		// one/both of PORT_FORWARD_TCP and/or PORT_FORWARD_UDP *must* be selected
		print ( $PORT_FORWARD and $PORT_FORWARD_UDP )
			? "
# Port-Weiterleitung aktiviert ist, so weitergeleitet Verkehrs akzeptieren
\$IPT -A FORWARD -p udp -i \$INET_IFACE --destination-port ".		(
				(( empty( $PORT_FORWARD_IPORT ))
					? ( $PORT_FORWARD_FROM . (( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO"))
					: $PORT_FORWARD_IPORT
				) ." \\\n     --destination $PORT_FORWARD_IP -j ACCEPT\n\n"
			)
			: '';

		print ( $PORT_FORWARD and $PORT_FORWARD_TCP )
			? "
\$IPT -A FORWARD -p tcp -i \$INET_IFACE --destination-port ".
			(
				(( empty( $PORT_FORWARD_IPORT ))
					? ( $PORT_FORWARD_FROM . (( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO"))
					: $PORT_FORWARD_IPORT
				) ." \\\n     --destination $PORT_FORWARD_IP -j ACCEPT\n\n"
			)
			: '';

		print "# Melden Sie sich Pakete, die noch nicht übereinstimmen";

		// Check LOG_FIREPARSE to determine log-prefix format
		print ( $LOG_FIREPARSE )
			? "
\$IPT -A FORWARD -j LOG --log-prefix \"fp=FORWARD:99 a=DROP \"
"
			: "
\$IPT -A FORWARD -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"FORWARD packet died: \"
";
	}
?>

###############################################################################
#
# OUTPUT Kette
#

echo "Prozess OUTPUT-Kette ... "

# Generell vertrauen die Firewall auf Ausgang

# Allerdings müssen ungültige ICMP-Pakete fallen gelassen werden, um zu
# verhindern eine mögliche nutzen.
$IPT -A OUTPUT -m state -p icmp --state INVALID -j DROP

# Localhost
$IPT -A OUTPUT -p ALL -s $LO_IP -j ACCEPT
$IPT -A OUTPUT -p ALL -o $LO_IFACE -j ACCEPT

<?php
	// If private network exists
	print ( $GATEWAY )
		? "
# Um interne Netzwerk
\$IPT -A OUTPUT -p ALL -s \$LOCAL_IP -j ACCEPT
\$IPT -A OUTPUT -p ALL -o \$LOCAL_IFACE -j ACCEPT

"
		: '';
?>
# Um internet
$IPT -A OUTPUT -p ALL -o $INET_IFACE -j ACCEPT

# Melden Sie sich Pakete, die noch nicht übereinstimmen
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "\$IPT -A OUTPUT -j LOG --log-prefix \"fp=OUTPUT:99 a=DROP \""
		: "\$IPT -A OUTPUT -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"OUTPUT packet died: \"";
?>


###############################################################################
#
# nat-tabelle
#
###############################################################################

# Der NAT-Tabelle ist, wo Netzwerkadressübersetzung tritt auf, wenn ein
# privates Netzwerk. Wird das Gateway zum Internet mit einer statischen IP
# verbunden ist, wird SNAT eingesetzt. Wenn das Gateway eine dynamische
# Adresse, muss Maskerade stattdessen verwendet werden. Es gibt mehr Overhead
# mit Maskerade verbunden, so SNAT ist besser, wenn sie verwendet werden kann.
# Der Tisch hat eine nat eingebauten Kette PREROUTING, für dnat und
# Weiterleitungen. Ein weiterer, POSTROUTING, Griffe SNAT und Maskerade.

echo "Load Regeln für nat-Tabelle ..."

###############################################################################
#
# PREROUTING Kette
#
<?php
	if( $PORT_FORWARD ) {
		// port forwarding option selected, build the rule here
		print "
# Port-Weiterleitung

# Port-Forwarding leitet den gesamten Datenverkehr auf einem Port oder die
# Ports von der Firewall an einem Computer im internen LAN. Dies kann
# erforderlich, um spezielle Situationen zu unterstützen. Zum Beispiel ist dies
# der einzige Weg, um Dateiübertragungen mit einem ICQ-Client auf einem
# internen Computer unterstützt. Es ist auch erforderlich, wenn ein internes
# System beherbergt einen Service wie Web-Server. Allerdings ist es auch eine
# gefährliche Option. Es ermöglicht Internet-Computer Zugriff auf das interne
# Netzwerk. Verwenden Sie es vorsichtig und nur, wenn Sie sicher sind,
# dass Sie wissen, was Sie tun.
";

		print ( $PORT_FORWARD_UDP )
			? "
\$IPT -t nat -A PREROUTING -p udp -i \$INET_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_TCP )
			? "
\$IPT -t nat -A PREROUTING -p tcp -i \$INET_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_REDIR and $PORT_FORWARD_UDP )
			? "
\$IPT -t nat -A PREROUTING -p udp -i \$LOCAL_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     --destination \$INET_ADDRESS -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_REDIR and $PORT_FORWARD_TCP )
			? "
\$IPT -t nat -A PREROUTING -p tcp -i \$LOCAL_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     --destination \$INET_ADDRESS -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		// If TRANSPARENT_PROXY option set, redirect port 80 and port 443 to the
		// REDIRECT_PORT on the gateway machine
		print ( $TRANSPARENT_PROXY )
			? "
# Dies ist ein Beispiel, die einen bestimmten Host aus der transparente Proxy
# befreit werden
#\$IPT -t nat -A PREROUTING -p tcp -s 192.168.1.50 --destination-port 80 \\
#     -j RETURN
#\$IPT -t nat -A PREROUTING -p tcp -s 192.168.1.50 --destination-port 443 \\
#     -j RETURN

# Leiten Sie HTTP für einen transparenten Proxy
\$IPT -t nat -A PREROUTING -p tcp --destination-port 80 \\
     -j REDIRECT --to-ports $REDIRECT_PORT

# Leiten Sie HTTPS für einen transparenten Proxy - standardmäßig auskommen
# \$IPT -t nat -A PREROUTING -p tcp --destination-port 443 \\
#     -j REDIRECT --to-ports $REDIRECT_PORT
"
			: '';
	}

	// For devices hosting both Web- and Mail-Servers on same IP
	print ( $BRAINDEAD )
			? "
# Redirect hirntot SMTP-Zugriffe von GoogleBot IPs zurück zu Web-
# Hinweis: httpd conf muss auch geeignete 301-Weiterleitungen auf dem Mail-Hostnamen
# See: http://forums.modem-help.co.uk/viewtopic.php?t=11680
# 2014-03-29 Dies ist die aktuelle googlebot CIDR: 66.249.64.0/19
$IPT -t nat -A PREROUTING -p tcp -s 66.249.64.0/19 \
     -m multiport --destination-port 25,110,143,995,993 -j LOG \
    --log-prefix \"BrainDead Google redirect: \"
$IPT -t nat -A PREROUTING -p tcp -s 66.249.64.0/19 \
  -m multiport --destination-port 25,110,143,995,993 -j REDIRECT --to-ports 80
"
			: '';
?>

###############################################################################
#
# POSTROUTING Kette
#

<?php
	//If it's a gateway then install either snat or masquerade.
	print ( $GATEWAY )
		? (( $DYNAMIC_IP )	// masquerade or snat
			? "\$IPT -t nat -A POSTROUTING -o \$INET_IFACE -j MASQUERADE\n"
			: "\$IPT -t nat -A POSTROUTING -o \$INET_IFACE \\
     -j SNAT --to-source \$INET_ADDRESS\n".
			(( $PORT_FORWARD_REDIR )
				? "\$IPT -t nat -A POSTROUTING -o \$LOCAL_IFACE \\
     -j SNAT --to-source \$INET_ADDRESS
"
				: ''
			)
		)
		: '';
?>

###############################################################################
#
# mangle-tabelle
#
###############################################################################

# Die mangle-Tabelle wird verwendet, um Pakete zu verändern. Es kann auf
# verschiedene Weise zu verändern oder zu zerfleischen sie. Für die Zwecke
# dieser Generator verwenden wir nur die Fähigkeit, die in TTL-Pakete ändern.
# Allerdings kann es verwendet werden, um Netfilter Markwerten auf bestimmte
# Pakete eingestellt werden. Diese Marken könnten dann in einer anderen Tabelle
# wie Filter verwendet werden, um Aktivitäten mit einem bestimmten Host, zum
# Beispiel zu begrenzen. Die TOS Ziel kann die Type of Service Feld im
# IP-Header gesetzt werden. Beachten Sie, dass der TTL-Ziel vielleicht nicht in
# der Distribution auf Ihrem System einbezogen werden. Wenn es nicht und Sie es
# benötigen, müssen Sie es hinzufügen. Das kann verlangen, dass Sie aus den
# Quellen bauen.

echo "Load Regeln für mangle-Tabelle ..."
<?php
	// Reset the TTL if requested to do so.
	print ( $MANGLE_TTL )
		? "
# Stellen Sie die TTL in ausgehenden Pakete an den gleichen konsistenten Wert.
# Ein Wert um 128 ist ein guter Wert. Diese zu hoch, da sie sich negativ auf
# das Netzwerk eingerichtet hat Sie nicht. Es gilt auch als schlechte Form im
# Internet.
\$IPT -t mangle -A OUTPUT -o \$INET_IFACE -j TTL --ttl-set $TTL
"
		: '';
// vi: shiftwidth=3 tabstop=3 et
?>
