<?php
/* FR/efg_firewall.inc
 *    PHP include script for efg.php,
 *    intended to show/deliver the actual firewall script
 *
 * 2014-03-29 v2.0.4 Added Braindead Google SMTP access redirection in PREROUTING chain
 * 2014-03-28 v2.0.3 Added dictionary attack prevention in INPUT Chain
 * 2014-03-27 v2.0.2 Added $MY_CIDR
 * 2014-03-22 v2.0.1 Added SYNACKANDNEW in bad_tcp_packets chain
 * 2014-03-18 v2.0.0 Released
 * 2014-02-27 v2.0.0 Started -AK
 *
 * TAB=3
 *
 * @category Net
 * @version $Id: FR/efg_firewall.inc, v2.0.4 2014-03-29
 * @author Alex KEMP http://www.modem-help.co.uk/
 * @translator sklerder AKA Phénix http://www-orange-sans-guigne.com
 *
 * (START original header)
 * Copyright 2002 Timothy Scott Morizot
 *
 * This file is part of my Easy Firewall Generator for IPTables.
 *
 * Easy Firewall Generator for IPTables is free software;
 * you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Easy Firewall Generator for IPTables is distributed
 * in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this distribution; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * (next line now set by Conteg)
 * //Set type to plain text
 * header("Content-Type: text/plain");
 * (FINISH original header)
 *
 * script transcribed to avoid use of untested '$_POST()' variables
 */

?>
#!/bin/sh
#
###############################################################################
#
# Script de pare-feu iptables généré pour Linux 2.4, 2.6 + noyau plus tard
<?php
	print "# Script généré par Easy Firewall Generator pour IPTables $VERSION
# (v2.0.0 fondée directement sur EFG originale v1.17)
# Cette version       : droit d'auteur $YEAR_NOW Modem-Help, Ltd. ($HOME)
# Traduction (FR )    : droit d'auteur 2014 http://translate.google.com
# Vérification/corrections de traduction : sklerder AKA Phénix http://www-orange-sans-guigne.com
# Versions précédentes: droit d'auteur 2002 Timothy Scott Morizot (easyfwgen.morizot.net)
#
# Création            : $NOW
";
?>
#
# Commentaires Redhat chkconfig - le pare-feu doit être appliqué au plus tôt,
#                                 enlevé au plus tard
# chkconfig: 2345 08 92
# Description: Ce script applique ou supprime les règles de pare-feu iptables
#
# Paramètres utilisés:
<?php
	print "# INET_IFACE: $INET_IFACE
#     IP Internet: ". (( $DYNAMIC_IP )
	? $DYNAMIC_IP_YES_TITLE[ $_LANG ]
	: "{$DYNAMIC_IP_NO_TITLE[$_LANG]} ($INET_ADDRESS)"
) ."
#      Ordinateur: ". (( $GATEWAY )
	? "{$GATEWAY_YES_TITLE[$_LANG]}
#             LOCAL_IFACE: $LOCAL_IFACE
#                LOCAL_IP: $LOCAL_IP
#               LOCAL_NET: $LOCAL_NET
#             LOCAL_BCAST: $LOCAL_BCAST"
	: $GATEWAY_NO_TITLE[ $_LANG ]
) ."
#          Réseau: ". (( $SPECIAL_LAN )
	? (
		( $BLOCK_OUTBOUND )		? "({$BLOCK_OUTBOUND_TITLE[$_LANG]})"		: '').
		(( $INTERNAL_DHCP )		? "({$INTERNAL_DHCP_TITLE[$_LANG]})"		: '').
		(( $MANGLE_TTL )			? "({$MANGLE_TTL_TITLE[$_LANG]})"			: '').
		(( $PORT_FORWARD )		? "({$PORT_FORWARD_TITLE[$_LANG]})"			: '').
		(( $TRANSPARENT_PROXY )	? "({$TRANSPARENT_PROXY_TITLE[$_LANG]})"	: ''
	)
	: '(aucun)'
) ."
#        Allow In: ". (( $INBOUND_ALLOW )
	? (
		( $SELF_IN )				? "({$SELF_NET_TITLE[$_LANG]})"				: '').
		(( $DHCP_IN )				? "({$DHCP_IN_TITLE[$_LANG]})"				: '').
		(( $DNS_IN )				? "({$DNS_IN_TITLE[$_LANG]})"					: '').
		(( $IM_IN )					? "({$IM_IN_TITLE[$_LANG]})"					: '').
		(( $HTTP_IN )				? "({$HTTP_IN_TITLE[$_LANG]})"				: '').
		(( $FTP_IN )				? "({$FTP_IN_TITLE[$_LANG]})"					: '').
		(( $EMAIL_IN )				? "({$EMAIL_IN_TITLE[$_LANG]})"				: '').
		(( $NTP_IN )				? "({$NTP_IN_TITLE[$_LANG]})"					: '').
		(( $MDNSRESPONDER_IN )	? "({$MDNSRESPONDER_IN_TITLE[$_LANG]})"	: '').
		(( $MESSENGER_IN )		? "({$MESSENGER_IN_TITLE[$_LANG]})"			: '').
		(( $NFS_IN )				? "({$NFS_IN_TITLE[$_LANG]})"					: '').
		(( $OTHER_IN )				? "({$OTHER_IN_TITLE[$_LANG]})"				: '').
		(( $SSH_IN )				? "({$SSH_IN_TITLE[$_LANG]})"					: ''
	)
	: '(aucun)'
) ."
#       Fireparse: ". (( $LOG_FIREPARSE )
	? 'Oui'
	: 'Non'
) ."
# IRC utilisateur: ". (( $IRC_USER )
	? 'Oui'
	: 'Non'
) ."
#   Dict s'arrête: ". (( $DICT )
	? 'Oui'
	: 'Non'
). "\n";
?>
#
# Ce générateur est principalement conçu pour des installations RedHat,
# bien qu'il puisse être adapté à d'autres.
#
# Il peut être exécuté avec les arguments typiques 'start' et 'stop'.
# S'il est utilisé avec 'stop', il s'arrête après nettoyage du pare-feu.
# Les arguments 'save' et 'restore' sauvegarderont ou restaureront les règles
# contenues dans le fichier etc/sysconfig/iptables. Les arguments 'save' et 'restore'
# sont inclus afin de préserver la compatibilité avec le script init.d de RedHat
# ou de Fedora si vous préférez les utiliser.

# Instructions d'installation sur Redhat/Fedora/CentOS
#
# 1. Faire en sorte que le lien du système init.d script démarre iptables dans
#    les niveaux 2, 3 et 5:
#    chkconfig --level 235 iptables on
#
# 2. Sauvegarder ce script et l'exécuter pour charger le jeu de règles de ce fichier.
#    Vous devrez peut-être exécuter la commande dos2unix sur lui pour supprimer
#    les retours chariot.
#
# 3. Pour qu'il appliqué au démarrage, copiez ce script dans /etc/init.d/iptables.
#    Il accepte les arguments 'stop', 'start', 'save', et 'restore'.
#    (Vous pouvez sauvegarder l'existant en premier.)
#    Alternativement, si vous exécutez des commandes 'service iptables save',
#    le script init.d devrait enregistrer les règles et les recharger à l'exécution.
#
# 4. Pour les systèmes non-Redhat (ou systèmes Redhat si vous avez un problème),
#    vous pouvez ajouter la commande pour exécuter ce script dans 'rc.local'.
#    'rc.local' se trouve généralement dans '/etc' et '/etc/rc.d', et est généralement
#    la dernière chose exécuté au démarrage. Il suffit d'ajouter
#    '/path/to/script/nom_script' sur une nouvelle ligne dans le fichier 'rc.local'.

###############################################################################
#
# Local Settings
#

# Emplacement de sysctl. Si elle est définie, sysctl sera utilisé pour ajuster
# les paramètres du noyau. Si ce paramètre est renseigné avec une chaîne vide
# (ou est désactivé), l'utilisation de sysctl est désactivée.

SYSCTL="/sbin/sysctl -w"

# Pour mettre la valeur directement dans le fichier /proc :
# SYSCTL=""

# Emplacement de IPTables - ajuster si nécessaire

IPT="/sbin/iptables"
IPTS="/sbin/iptables-save"
IPTR="/sbin/iptables-restore"

# Interface Internet
<?php
print "INET_IFACE=\"$INET_IFACE\"\n";
print ( $DYNAMIC_IP )
	? ''
	: "INET_ADDRESS=\"$INET_ADDRESS\"\n";
print ( $GATEWAY )
	? "
# Local Interface Information
LOCAL_IFACE=\"$LOCAL_IFACE\"
LOCAL_IP=\"$LOCAL_IP\"
LOCAL_NET=\"$LOCAL_NET\"
LOCAL_BCAST=\"$LOCAL_BCAST\"
"
	: '';
print ( $SELF_IN )
	? "
# Accès de l'administrateur réseau
MY_CIDR=\"$SELF_NET\"
"
	: '';
?>

# Interface Localhost

LO_IFACE="lo"
LO_IP="127.0.0.1"

# Les arguments 'save' et 'restore' sont traités ici
if [ "$1" = "save" ]
then
	echo -n "Sauvegarde des règles du pare-feu dans /etc/sysconfig/iptables ... "
	$IPTS > /etc/sysconfig/iptables
	echo "Fini."
	exit 0
elif [ "$1" = "restore" ]
then
	echo -n "Restauration des règles du pare-feu depuis /etc/sysconfig/iptables ... "
	$IPTR < /etc/sysconfig/iptables
	echo "Fini."
	exit 0
fi

###############################################################################
#
# Chargement des modules
#

echo "Chargement des modules du noyau ..."

# Vous devez décommenter la ligne ci-dessous et lancer la première fois
# juste pour s'assurer que toutes les dépendances de modules du noyau
# sont OK. Il n'est pas nécessaire de l'exécuter à chaque fois, cependant.

# /sbin/depmod -a

# Sauf si l'auto-chargement de modules du noyau est désactivé,
# vous ne devriez pas avoir besoin de charger manuellement l'un de ces modules.
# A part ip_tables, ip_conntrack, et quelques modules optionnels,
# je les ai laissés commentés par défaut. Décommentez si vous avez des problèmes
# ou si vous avez désactivé l'autoload de modules. Notez que certains modules
# doivent être chargés par un autre module du noyau.

# module de base netfilter
/sbin/modprobe ip_tables

# le module de suivi de connexion avec état
/sbin/modprobe ip_conntrack

# module de table de filtrage
# /sbin/modprobe iptable_filter

# module de la table mangle
# /sbin/modprobe iptable_mangle

# module de la table nat
# /sbin/modprobe iptable_nat

# module de cible LOG
# /sbin/modprobe ipt_LOG

# Il est utilisé pour limiter le nombre de paquets par seconde/minute/heure
# /sbin/modprobe ipt_limit

# module cible de masquage
# /sbin/modprobe ipt_MASQUERADE

# filtrer sur le propriétaire dans le cadre du corrélations
# /sbin/modprobe ipt_owner

# la cible 'REJECT' abandonne le paquet et renvoie une réponse ICMP.
# La réponse est configurable. Par défaut, connexion refusée.
# /sbin/modprobe ipt_REJECT

# Cette cible permet de marquer des paquets dans la table mangle
# /sbin/modprobe ipt_mark

# Cette cible concerne le TCP MSS
# /sbin/modprobe ipt_tcpmss

# Ce 'match' permet d'utiliser plusieurs ports au lieu d'un seul port ou une plage
# /sbin/modprobe multiport

# Ce 'match' contrôle les drapeaux TCP
# /sbin/modprobe ipt_state

# Ce 'match' contrôle contre les drapeaux invalides
# /sbin/modprobe ipt_unclean

# Le module ftp nat est nécessaire pour le support ftp non-PASV (FTP non passif)
<?php
	print ( $FTP_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_nat_ftp

# le module pour le suivi complet de connexion ftp
<?php
	print ( $FTP_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_conntrack_ftp

# le module pour le suivi complet de connexion irc
<?php
	print ( $IRC_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_conntrack_irc


###############################################################################
#
# Configuration des paramètres du noyau
#
# Voir http://ipsysctl-tutorial.frozentux.net/chunkyhtml/index.html pour
# un tutoriel détaillé sur sysctl et les différents réglages disponibles.

# Nécessaire pour activer le transfert IPv4.
# Les utilisateurs de RedHat peuvent essayer de régler FORWARD_IPV4 dans
# /etc/sysconfig/network à 'true'. Sinon, il peut être mis dans /etc/sysctl.conf
<?php
	print ( $GATEWAY )
		? "if [ \"\$SYSCTL\" = \"\" ]
then
    echo \"1\" > /proc/sys/net/ipv4/ip_forward
else
    \$SYSCTL net.ipv4.ip_forward=\"1\"
fi"
		: "#if [ \"\$SYSCTL\" = \"\" ]
#then
#    echo \"1\" > /proc/sys/net/ipv4/ip_forward
#else
#    \$SYSCTL net.ipv4.ip_forward=\"1\"
#fi";
?>


# Ceci permet d'utiliser l'adressage dynamique.
# Ca peut aider si vous avez une adresse IP dynamique (par exemple, slip, ppp, dhcp).
#if [ "$SYSCTL" = "" ]
#then
#    echo "1" > /proc/sys/net/ipv4/ip_dynaddr
#else
#    $SYSCTL net.ipv4.ip_dynaddr="1"
#fi

# Ceci permet une protection contre les dénis de service SYN.
# L'activation des cookies SYN permet à votre système d'accepter un nombre
# illimité de connexions TCP tout en essayant de donner un service raisonnable
# pendant un déni de service.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/tcp_syncookies
else
    $SYSCTL net.ipv4.tcp_syncookies="1"
fi

# Ceci permet la validation de la source par chemin inverse selon RFC1812.
# En d'autres termes, le paquet de réponse provient-il de la même interface
# que celle par laquelle a été envoyé le paquet source? Il est recommandé pour
# les systèmes et les routeurs monorésidents sur les réseaux d'extrémité. Puisque
# ce sont les configurations pour lesquelles ce pare-feu est conçu, je l'active par défaut.
# Désactivez-le si vous utilisez plusieurs cartes réseau connectés au même réseau.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/rp_filter
else
    $SYSCTL net.ipv4.conf.all.rp_filter="1"
fi

# Cette option permet à un sous-réseau d'être protégé par un pare-feu avec une adresse IP unique.
# Il est utilisé pour construire une DMZ. Comme ce n'est pas l'objet de ce script
# de pare-feu, il n'est pas activé par défaut, mais il est inclus pour référence.
# Voir: http://www.sjdjweis.com/linux/proxyarp/
#if [ "$SYSCTL" = "" ]
#then
#    echo "1" > /proc/sys/net/ipv4/conf/all/proxy_arp
#else
#    $SYSCTL net.ipv4.conf.all.proxy_arp="1"
#fi

# Les paramètres de noyau suivants ont été suggérées par Alex Weeks. Merci!

# Ce paramètre de noyau demande au noyau d'ignorer toutes les demandes d'écho ICMP envoyés
# à l'adresse de diffusion. Cela empêche un certain nombre de 'smurf'
# et autres attaques malveillantes par déni de service.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/icmp_echo_ignore_broadcasts
else
    $SYSCTL net.ipv4.icmp_echo_ignore_broadcasts="1"
fi

# Cette option peut être utilisée pour accepter ou refuser les paquets routés
# par la source. Il est généralement activé par défaut, mais est généralement
# considéré comme un risque de sécurité. Cette option le désactive.
if [ "$SYSCTL" = "" ]
then
    echo "0" > /proc/sys/net/ipv4/conf/all/accept_source_route
else
    $SYSCTL net.ipv4.conf.all.accept_source_route="0"
fi

# Cette option peut désactiver les redirections ICMP. Les redirections ICMP
# sont généralement considérés comme un risque de sécurité et ne devraient
# pas être nécessaires par la plupart des systèmes utilisant ce générateur.
#if [ "$SYSCTL" = "" ]
#then
#    echo "0" > /proc/sys/net/ipv4/conf/all/accept_redirects
#else
#    $SYSCTL net.ipv4.conf.all.accept_redirects="0"
#fi

# Cependant, nous ferons en sorte que l'option secure_redirects soit activée. Cette option
# accepte seulement les passerelles dans la liste des passerelles par défaut.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/secure_redirects
else
    $SYSCTL net.ipv4.conf.all.secure_redirects="1"
fi

# Cette option enregistre les paquets provenant des adresses impossibles.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/log_martians
else
    $SYSCTL net.ipv4.conf.all.log_martians="1"
fi


###############################################################################
#
# Nettoyer les règles ou les chaînes existantes
#

echo "Nettoyage des tables ..."

# Reset Default Policies
$IPT -P INPUT ACCEPT
$IPT -P FORWARD ACCEPT
$IPT -P OUTPUT ACCEPT
$IPT -t nat -P PREROUTING ACCEPT
$IPT -t nat -P POSTROUTING ACCEPT
$IPT -t nat -P OUTPUT ACCEPT
$IPT -t mangle -P PREROUTING ACCEPT
$IPT -t mangle -P OUTPUT ACCEPT

# Nettoyer toutes les règles
$IPT -F
$IPT -t nat -F
$IPT -t mangle -F

# Effacer toutes les chaînes non-existantes par défaut
$IPT -X
$IPT -t nat -X
$IPT -t mangle -X

if [ "$1" = "stop" ]
then
	echo "Pare-feu complètement nettoyé! Actuellement, exécution san pare-feu."
	exit 0
fi

###############################################################################
#
# Configuration des règles
#

###############################################################################
#
# Table Filter
#
###############################################################################

# Définition des polices

$IPT -P INPUT DROP
$IPT -P OUTPUT DROP
$IPT -P FORWARD DROP

###############################################################################
#
# Chaînes spécifiées par l'utilisateur
#
# Créer des chaînes utilisateur afin de réduire le nombre de règles que chaque paquet
# doit traverser.

echo "Créer et remplir des chaînes personnalisées de règles ..."

# Créer une chaîne pour filtrer les paquets INVALID
$IPT -N bad_packets

# Créer une autre chaîne pour filtrer les mauvais paquets tcp
$IPT -N bad_tcp_packets

# Créez des chaînes distinctes pour ICMP, TCP (entrant et sortant), et les paquets UDP entrants.
$IPT -N icmp_packets

# Utilisé pour les paquets UDP entrants en provenance d'Internet
$IPT -N udp_inbound

# Utilisé pour bloquer les services UDP sortants du réseau interne
# Par défaut, autoriser tous
$IPT -N udp_outbound

# Utilisé pour permettre aux services entrants si vous le souhaitez
# Échec par défaut sauf pour les sessions établies
$IPT -N tcp_inbound

# Utilisé pour bloquer les services sortants du réseau interne
# Par défaut, autoriser tous
$IPT -N tcp_outbound

###############################################################################
#
# Remplir les chaînes utilisateur
#

###############################################################################
#
# chaîne bad_packets
#
<?php
	// Rules for the private network
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $GATEWAY )
		? "
# Paquets de baisse reçues sur l'interface externe
# réclamant une source sur le réseau local
\$IPT -A bad_packets -p ALL -i \$INET_IFACE -s \$LOCAL_NET -j LOG \
".		(( $LOG_FIREPARSE )
			? "    --log-prefix \"fp=bad_packets:2 a=DROP \""
			: "    --log-prefix \"Illegal source: \""
		). "

\$IPT -A bad_packets -p ALL -i \$INET_IFACE -s \$LOCAL_NET -j DROP
"
		: '';
?>

# Supprimer les paquets INVALID immédiatement
$IPT -A bad_packets -p ALL -m state --state INVALID -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_packets:1 a=DROP \""
		: "    --log-prefix \"Invalid packet: \"";
?>


$IPT -A bad_packets -p ALL -m state --state INVALID -j DROP

# Vérifier ensuite les paquets TCP pour des problèmes supplémentaires
$IPT -A bad_packets -p tcp -j bad_tcp_packets

# Tout bon, donc retour
$IPT -A bad_packets -p ALL -j RETURN

###############################################################################
#
# chaîne bad_tcp_packets
#
# Tous les paquets TCP traverseront cette chaîne.
# Chaque nouvelle tentative de connexion doit commencer par un paquet SYN.
# Si ce n'est pas, c'est probable un scan de ports. Ceci abandonne les paquets
# à l'état NEW qui ne sont pas marqués comme des paquets SYN.

<?php
	// If there is a gateway, exempt the internal interface.
	print ( $GATEWAY )
		? "
# Retour à la chaîne d'appel si les mauvais paquets proviennent de l'interface
# locale. Cela permet de maintenir l'approche tout au long de ce pare-feu
# d'un réseau interne largement de confiance.
\$IPT -A bad_tcp_packets -p tcp -i \$LOCAL_IFACE -j RETURN

# Cependant, à l'origine, j'appliquais ce filtre à la chaîne FORWARD
# les paquets en provenance du réseau interne.
# Bien que je n'ai pas pu déterminer clairement son effet, il semble avoir l'effet
# de bord intéressant de bloquer certains des systèmes d'annonces.
# Apparemment, certains systèmes de publicité utilisent le navigateur pour établir
# une nouvelle connexion qui n'est pas marqué comme un paquet de synthèse
# pour récupérer l'image publicitaire. Si vous souhaitez l'expérimenter davantage
# commenter la règle ci-dessus. Si vous l'essayez, vous
# pouvez également supprimer le commentaire de la règle ci-dessous.
# Elle empêchera ces paquets d'être enregistrés. Il y en a beaucoup de ce type.
#\$IPT -A bad_tcp_packets -p tcp -i \$LOCAL_IFACE ! --syn -m state \\
#     --state NEW -j DROP
"
		: '';
?>

# 2014-03-22 ajoutée -AK
# Loi honorablement le compte de tiers bénéficiant TCP Numéro de séquence
# attaques de prévision (ces attaques reposent sur la DROP
# hôte usurpée inconnus SYN / ACK plutôt que de les rejeter).
# Voir https://www.frozentux.net/iptables-tutorial/iptables-tutorial.html#SYNACKANDNEW
$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,ACK SYN,ACK \
    -m state --state NEW -j REJECT --reject-with tcp-reset

# Fixer fonction iptables de permettre à de nouveaux paquets avec SYN peu désarmé
# Voir https://www.frozentux.net/iptables-tutorial/iptables-tutorial.html#NEWNOTSYN
$IPT -A bad_tcp_packets -p tcp ! --syn -m state --state NEW -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:1 a=DROP \""
		: "    --log-prefix \"New not syn: \"";
?>

$IPT -A bad_tcp_packets -p tcp ! --syn -m state --state NEW -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL NONE -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:2 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL NONE -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL ALL -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:3 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL ALL -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL FIN,URG,PSH -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:4 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL FIN,URG,PSH -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:5 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,RST SYN,RST -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:6 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,RST SYN,RST -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,FIN SYN,FIN -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:7 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,FIN SYN,FIN -j DROP

# Tout est bon, donc retour
$IPT -A bad_tcp_packets -p tcp -j RETURN

###############################################################################
#
# icmp_packets chaîne
#
# Cette chaîne est pour les paquets ICMP entrants (par Internet) seulement.
# Type 8 (Echo Request) n'est pas accepté par défaut. Activez-le si
# vous voulez que des hôtes distants puissent vous joindre.
# Type 11 (Temps dépassé) est la seule acceptée qui ne serait pas déjà
# couverte par la règle de connexion établie. Appliqué à INPUT sur l'interface externe.
#
# Voir: http://www.ee.siue.edu/~rwalden/réseaux/icmp.html pour
# plus d'informations sur les types ICMP.
#
# Notez que les paramètres avec état permettent les réponses aux paquets ICMP.
# Ces règles permettent de nouveaux paquets des types spécifiés.

# Les paquets ICMP doivent s'inscrire dans un cadre de niveau 2, donc ils
# ne devraient jamais être fragmentés. Paquets ICMP fragmentés sont un
# signe typique d'un déni de service.
$IPT -A icmp_packets --fragment -p ICMP -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=icmp_packets:1 a=DROP \""
		: "    --log-prefix \"ICMP Fragment: \"";
?>

$IPT -A icmp_packets --fragment -p ICMP -j DROP

# Echo - décommenter pour permettre à votre système d'être testé par 'ping'.
# Décommenter la commande LOG si vous aussi vous voulez vous enregistrer les tentatives de PING
#
# $IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "#    --log-prefix \"fp=icmp_packets:2 a=ACCEPT \""
		: "#    --log-prefix \"Ping detected: \"";
?>

# $IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j ACCEPT

# Par défaut, cependant, abandonner les pings sans enregistrement.
# Blaster et autres vers ont infecté les systèmes en polluant avec des pings.
# Commentez la ligne ci-dessous si vous voulez journaliser les pings,
# mais ça remplira probablement vos journaux.
$IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j DROP

# Temps dépassé
$IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 11 -j ACCEPT

# Pas identifié, donc retour pour qu'il soit journalisé
$IPT -A icmp_packets -p ICMP -j RETURN

###############################################################################
#
# TCP & UDP
# Identifier les ports sur :
#    http://www.chebucto.ns.ca/~rakerman/port-table.html
#    http://www.iana.org/assignments/port-numbers

###############################################################################
#
# chaîne de udp_inbound
#
# Cette chaîne décrit les paquets UDP entrants qui seront acceptés.
# Elle est appliquée à l'entrée sur l'interface externe ou Internet.
# Notez que les paramètres avec état permettent réponses. Ces règles
# sont pour les nouvelles demandes. Il ignore les paquets NetBIOS
# (Windows) immédiatement sans journalisation.

# Abandonner les appels NetBIOS
# Veuillez noter que ces règles ne changent pas vraiment la façon
# dont le pare-feu traite les connexions NetBIOS. Les connexions des
# interfaces localhost et interne (s'il en existe) sont acceptés par
# défaut. Les réponses de l'Internet à des demandes initiées par ou via
# le pare-feu sont également acceptés par défaut. Pour arriver ici,
# les paquets devraient faire partie d'une nouvelle demande reçue
# par l'interface Internet. Vous auriez à ajouter manuellement des règles
# pour accepter ces derniers. J'ai ajouté ces règles parce que certaines
# connexions réseau, telles que celles via les modems câbles,
# ont tendance à être polluées avec le bruit de machines Windows non
# protégés. Ces règles laissent tomber les paquets rapidement
# et sans les journaliser. Ceci les empêche de traverser toute la chaîne
# et empêche les journaux d'être encombrés des bavardages des systèmes Windows.
$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 137 -j DROP
$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 138 -j DROP

<?php
	// Reject ident requests. IRC User
	print ( $IRC_USER )
		? "
# Les requêtes IRC Ident (port 113) doivent avoir une règle REJECT plutôt
# que la règle DROP par défaut. C'est le minimum requis pour éviter
# de longs délais lors de la connexion. Voir également la règle dans tcp_inbound.
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 113 -j REJECT

# Une configuration plus sophistiquée pourrait accepter les demandes d'ident.
#\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 113 -j ACCEPT
".		(( $GATEWAY )
			? "
# Toutefois, s'il s'agit d'un système de passerelle qui se déguise/'natte'
# pour les systèmes internes et les systèmes internes souhaitant 'tchatter',
# une simple modification de ces règles en ACCEPT ne fonctionnera pas.
# Le démon ident sur la passerelle aura besoin de savoir comment
# gérer les demandes. Le démon de base dans la plupart des distributions
# Linux ne peut pas le faire. oidentd est un package qui peut.
# Voir: http://dev.ojnk.net/
"
			: ''
		)
		: '';

	// NTP server on gateway
	print ( $NTP_IN )
		? "
# Serveur Network Time Protocol (NTP)
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 123 -j ACCEPT
"
		: '';

	// DNS Server - TCP (most are UDP, so this could be disabled)
	print ( $DNS_IN )
		? "
# Serveur DNS
# Configurer le serveur pour utiliser le port 53 comme port source
# pour les demandes. Notez que si vous exécutez un serveur de noms-cache
# uniquement, qui n'accepte que des requêtes du réseau privé ou de localhost,
# vous pouvez commenter cette ligne.
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 53 -j ACCEPT

# Si vous n'interrogez pas le serveur sur le port 53 et si vous avez des problèmes,
# décommentez cette règle. Elle autorise en particulier les réponses aux
# requêtes initiés vers un autre serveur à partir d'un port UDP élevé.
# Les règles de connexion avec état devraient gérer cette situation, cependant.
#\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 53 -j ACCEPT
"
		: '';

	// mDNSResponder
	print ( $MDNSRESPONDER_IN )
		? "
# mDNSResponder
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 5353 -j ACCEPT
"
		: '';

	// If running a DHCP server on the Internet interface, allow the requests
	print ( $DHCP_IN )
		? "
# DHCP serveur externe
# Autoriser une requête de client DHCP en paquets entrants depuis le réseau externe
\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 68 --destination-port 67 \\
     -j ACCEPT
"
		: '';
	// If it's a dynamic address, set rule to allow inbound DHCP
	print ( $DYNAMIC_IP )
		? "
# Adresse Dynamique
# Si DHCP, la demande initiale est une diffusion globale (broadcast).
# La réponse ne correspond pas exactement au paquet sortant.
# Ce qui suit autorise explicitement les ports DHCP pour atténuer ce problème.
# Si vous recevez votre adresse dynamique par un autre moyen, vous pouvez
# probablement commenter cette ligne.
\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 67 --destination-port 68 \\
     -j ACCEPT
"
		: '';

	// Inbound NFS selected
	print ( $NFS_IN )
		? "
# Système de fichiers réseau (Serveur NFS)
# Veuillez noter que les services supplémentaires doivent être
# configurés afin de supporter un serveur NFS à travers le pare-feu.
# Lire l'aide dans le générateur ou dans ce site :
# http://www.lowth.com/LinWiz/nfs_help.html

# Serveur NFS
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 111 -j ACCEPT

# Serveur NFS - statd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $STATD_PORT -j ACCEPT

# Serveur NFS - NFS daemon
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 2049 -j ACCEPT

# Serveur NFS - lockd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $LOCKD_PORT -j ACCEPT

# Serveur NFS - mountd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $MOUNTD_PORT -j ACCEPT

# Serveur NFS - quotad
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $RQUOTAD_PORT -j ACCEPT
"
		: '';

	// User specified inbound rule
	print ( $OTHER_IN and $OTHER_IN_UDP )
		? "
# Protocole UDP spécifié apr l'utilisateur autorisé
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $OTHER_IN_FROM".
(( empty( $OTHER_IN_TO )) ? '' : ":$OTHER_IN_TO")." -j ACCEPT
"
		: '';
?>

# Pas identifié, donc retour pour journalisation
$IPT -A udp_inbound -p UDP -j RETURN

###############################################################################
#
# chaîne udp_outbound
#
# Cette chaîne est utilisée avec un réseau privé pour empêcher
# la redirection des demandes UDP sur des protocoles spécifiques.
# Appliquée à la règle FORWARD du réseau interne. Se termine par un ACCEPT

<?php
	// If IM blocked, block ICQ, which uses UDP 4000
	print ( $IM_OUT )
		? "
# ICQ utilise UDP 4000 - La messagerie instantanée bloqué
\$IPT -A udp_outbound -p UDP -s 0/0 --destination-port 4000 -j REJECT
"
		: '';
?>

# Aucun résultat, donc ACCEPT
$IPT -A udp_outbound -p UDP -s 0/0 -j ACCEPT

###############################################################################
#
# chaîne tcp_inbound
#
# Cette chaîne est utilisée pour autoriser les connexions entrantes
# sur le système/passerelle. À utiliser avec précaution. Par défaut, c'est NONE.
# Elle est appliquée sur INPUT de l'interface externe/Internet.

<?php
	// allow own IP/CIDR through
print ( $SELF_IN )
	? "
# Autoriser soi à travers (une adresse IP statique / CIDR est le meilleur)
# Pour affiner l'accès autorisé, décommentez cette règle et commenter la règle INPUT
# (Puis ajouter ou supprimer des ports que nécessaire)
#\$IPT -A tcp_inbound -p TCP -s \$MY_CIDR -m multiport --destination-ports 21,22 -j ACCEPT
"
	: '';

	// Reject ident requests. IRC User
	print ( $IRC_USER )
		? "
# Demandes IRC Ident (port 113) doivent avoir une règle REJECT plutôt
# que la règle DROP par défaut. C'est le minimum requis pour éviter de
# longs délais lors de la connexion. Voir également la règle de udp_inbound.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 113 -j REJECT

# Une configuration plus sophistiquée pourrait accepter les demandes d'ident.
#\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 113 -j ACCEPT
".		(( $GATEWAY )
			? "
# Toutefois, s'il s'agit d'un système de passerelle qui se masque/'natte'
# pour les systèmes internes et si les systèmes internes souhaitent 'tchatter',
# une simple modification de ces règles ACCEPT ne fonctionnera pas.
# Le démon ident sur la passerelle aura besoin de savoir comment gérer
# les demandes. Le démon de base de la plupart des distributions Linux
# ne peut pas le faire. oidentd est un package qui peut.
# See: http://dev.ojnk.net/
"
			: ''
		)
		: '';

//DNS Server - TCP (most are UDP, so this could be disabled)
	print ( $DNS_IN )
		? "
# Serveur DNS - Autoriser les connexions TCP (transferts de zone et
# de grosses requêtes). Cette option est désactivée par défaut.
# Les transferts de zone DNS se produisent via TCP. Si vous avez besoin
# d'autoriser les transferts sur le net, vous devez décommenter cette ligne.
# Si vous autorisez les requêtes de le 'net', vous devez également être
# conscient que, bien que les requêtes DNS utilisent UDP par défaut,
# une requête UDP tronquée peut légalement être soumis via TCP à la place.
# Vous n'aurez probablement jamais besoin, mais devriez être au courant de ce fait.
# \$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 53 -j ACCEPT
"
		: '';

	// mDNSResponder
	print ( $MDNSRESPONDER_IN )
		? "
# mDNSResponder
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 5353 -j ACCEPT
"
		: '';

	// HTTP
	print ( $HTTP_IN )
		? "
# HTTP Web Server
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 80 -j ACCEPT
"
		: '';

	// HTTPS
	print ( $HTTPSSL_IN )
		? "
# HTTPS (Secure Web Server)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 443 -j ACCEPT
"
		: '';

	if( $FTP_IN ) {
		// FTP
		print "
# FTP Server (Control)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 21 -j ACCEPT

# Client FTP (Port de données pour les transferts non 'passifs')
\$IPT -A tcp_inbound -p TCP -s 0/0 --source-port 20 -j ACCEPT

# FTP passif
#
# Avec FTP passif, le serveur dispose d'un port pour le client et
# permet au client d'ouvrir la connexion plutôt que l'ouverture
# de la connexion avec le client à partir du port de données.
# Les navigateurs Web et les clients opérant derrière un pare-feu
# utilisent généralement des transferts ftp passifs.
# Un serveur FTP d'usage général devra les soutenir.
#
# Cependant, par défaut un serveur FTP sélectionnera un port dans
# l'ensemble des ports élevés. Ce n'est pas particulièrement
# sûr d'ouvrir tous les ports élevés. Heureusement, cette
# plage peut être restreinte. Ce pare-feu suppose que la plage
# a été limitée à une plage sélectionnée spécifique.
# Cette palge doit également être configuré dans le serveur ftp.
#
# Des instructions pour spécifier la plage de ports sur le serveur
# wu-ftpd peuvent être trouvés ici :
# http://www.wu-ftpd.org/man/ftpaccess.html
# (Voir l'option des ports passifs.)
#
# Des instructions pour le serveur ProFTPD peuvent être trouvés ici :
# http://proftpd.linux.co.uk/localsite/Userguide/linked/x861.html
";

		// Passive FTP
		print ( $PASSIVE_IN )
			? "
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $PASSIVE_PORT_FROM:$PASSIVE_PORT_TO -j ACCEPT
"
			: "
# Règle de l'échantillon
# \$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 62000:64000 -j ACCEPT
";
	}

	// Email
	print ( $EMAIL_IN )
		? "
# Serveur de messagerie (SMTP)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 25 -j ACCEPT

# Serveur de messagerie (POP3)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 110 -j ACCEPT

# Serveur de messagerie (IMAP4)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 143 -j ACCEPT
"
		: '';

	print ( $EMAILSSL_IN )
		? "
# SSL Serveur de messagerie (POP3)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 995 -j ACCEPT

# SSL Serveur de messagerie (IMAP4)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 993 -j ACCEPT
"
		: '';

	// SSH
	print ( $SSH_IN )
		? "
# SSH
# MH aide : Telle que fournie, la ligne suivante permet des connexions
# SSH de n'importe quelle source ('-s 0/0). Cela conduira à des
# centaines de tentatives de connexions quotidiennes d'adresses IP,
# qui tentent des attaques par dictionnaire sur votre système.
# Si possible, il est fortement conseillé de placer votre propre
# IP/CIDR en remplacement : Par exemple '-s \$MY_IP' ou '-s \$MY_CIDR'.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 22 -j ACCEPT
"
		: '';

	// ICQ
	print ( $IM_IN )
		? "
# Transferts de fichiers ICQ et autres fonctions avancées
#
# ICQ prend en charge un certain nombre d'options au-delà de
# la messagerie instantanée simple. Pour que celles-ci fonctionnent,
# le système de messagerie instantanée doit permettre de nouvelles
# connexions initiées à partir de systèmes distants. Cette option
# va ouvrir une plage de port spécifique sur le système de pare-feu.
# Le client ICQ sur le système pare-feu doit être configuré pour
# utiliser la même plage de port spécifique.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $IM_PORT_FROM:$IM_PORT_TO -j ACCEPT
"
		: '';

	// MSN Messenger
	print ( $MESSENGER_IN )
		? "
# MSN Messenger transferts de fichiers
#
# Messenger prend en charge les transferts de fichiers. Pour que
# les transferts initiés par des systèmes distants fonctionnent,
# le système doit autoriser les nouvelles connexions initiées
# à partir de systèmes distants sur une plage de ports spécifique.
# Cette option est par défaut sur la plage de ports 6891 par 6900.
# Sauf si le client MSN Messenger peut être configuré pour
# spécifier n'importe quelle plage de ports, ne modifiez pas la valeur par défaut.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $MSN_PORT_FROM:$MSN_PORT_TO -j ACCEPT
"
		: '';

	// Inbound NFS selected
	print ( $NFS_IN )
		? "
# Système de fichiers réseau (NFS) Serveur
#
# Veuillez noter que les services supplémentaires doivent
# être configurés afin de supporter un serveur NFS à travers
# le pare-feu. Lire l'aide dans le générateur ou sur ce site :
# http://www.lowth.com/LinWiz/nfs_help.html

# Serveur NFS - portmapper
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 111 -j ACCEPT

# Serveur NFS - statd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $STATD_PORT -j ACCEPT

# Serveur NFS - NFS daemon
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 2049 -j ACCEPT

# Serveur NFS - lockd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $LOCKD_PORT -j ACCEPT

# Serveur NFS - mountd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $MOUNTD_PORT -j ACCEPT

# Serveur NFS - quotad
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $RQUOTAD_PORT -j ACCEPT
"
		: '';

	// User specified inbound rule
	print ( $OTHER_IN and $OTHER_IN_TCP )
		? "
# Protocole TCP spécifié par l'utilisateur autorisé
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $OTHER_IN_FROM".
(( empty( $OTHER_IN_TO )) ? '' : ":$OTHER_IN_TO")." -j ACCEPT
"
		: '';
?>

# Pas identifié, donc retour et sera journalisé
$IPT -A tcp_inbound -p TCP -j RETURN

###############################################################################
#
# Chaîne tcp_outbound
#
# Cette chaîne est utilisée avec un réseau privé pour empêcher
# la redirection des demandes sur des protocoles spécifiques.
# Appliquée à la règle FORWARD du réseau interne. Se termine par un ACCEPT

<?php
	// IRC
	print ( $IRC_OUT )
		? "
# Bloquer IRC
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 194 -j REJECT
"
		: '';

	// telnet
	print ( $TELNET_OUT )
		? "
# Bloquer Telnet sortant
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 23 -j REJECT
"
		: '';

	// ssh
	print ( $SSH_OUT )
		? "
# Bloquer SSH
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 22 -j REJECT
"
		: '';

	// usenet
	print ( $NEWS_OUT )
		? "
# Bloquer l'accès à Usenet
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 119 -j REJECT
"
		: '';

	// web
	print ( $HTTP_OUT )
		? "
# Bloquer l'accès au Web
# HTTP
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 80 -j REJECT

# HTTPS (Secure Web)
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 443 -j REJECT
"
		: '';

	// ftp
	print ( $FTP_OUT )
		? "
# Bloquer l'accès à FTP
# Control
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 21 -j REJECT

# Data
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 20 -j REJECT
"
		: '';

	// Instant Messaging
	print ( $IM_OUT )
		? "
# Bloquer la messagerie instantanée
# AIM
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 5190 -j REJECT

# Images AIM
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 4443 -j REJECT

# MSN Messenger
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 1863 -j REJECT
"
		: '';

	// Instant Messaging
	print ( $EMAIL_OUT )
		? "
# Bloquer l'accès Email aux serveurs externes
# SMTP
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 25 -j REJECT

# POP3
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 110 -j REJECT

# IMAP4
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 143 -j REJECT
"
		: '';
?>

# Aucun résultat, donc ACCEPT
$IPT -A tcp_outbound -p TCP -s 0/0 -j ACCEPT

###############################################################################
#
# Chaîne INPUT
#

echo "Traitement de la chaîne INPUT ..."

# Autoriser tout sur l'interface localhost
$IPT -A INPUT -p ALL -i $LO_IFACE -j ACCEPT

# Abandonner les mauvais paquets
$IPT -A INPUT -p ALL -j bad_packets

# Modems câbles compatibles DOCSIS
# Certains modems câbles compatibles DOCSIS envoyent des paquets IGMP en multicast
# pour trouver les PC connectés. Les paquets de multidiffusion ont l'adresse
# de destination 224.0.0.1. Vous pouvez les accepter. Si vous choisissez
# de le faire, décommentez la règle pour les accepter et commenter
# la règle pour les laisser tomber. Le pare-feu les abandonnera à ce stade par
# défaut pour éviter d'encombrer le journal. Le pare-feu abandonnera
# toutes les multidiffusions vers l'ensemble du sous-réseau (224.0.0.1)
# par défaut. Pour seulement affecter les multidiffusions IGMP,
# changer '-p ALL' en 'p-2'. Bien sûr, si elles ne sont pas acceptées
# ailleurs, ça ne fera que faire en sorte que les multidiffusions
# sur d'autres protocoles soient journalisées.
# Abandonnez-les sans journalisation.
$IPT -A INPUT -p ALL -d 224.0.0.1 -j DROP
# La règle pour accepter les paquets.
# $IPT -A INPUT -p ALL -d 224.0.0.1 -j ACCEPT

<?php
	if( $GATEWAY ) {
		// Rules for the private network
		print "
# Règles pour le réseau privé (accès système de la passerelle elle-même)
\$IPT -A INPUT -p ALL -i \$LOCAL_IFACE -s \$LOCAL_NET -j ACCEPT
\$IPT -A INPUT -p ALL -i \$LOCAL_IFACE -d \$LOCAL_BCAST -j ACCEPT
";

		// If running DHCP internally from this server, also allow dhcp client requests
		print ( $INTERNAL_DHCP )
			? "
# Autoriser les paquets entrants émanant de clients DHCP depuis le réseau interne
\$IPT -A INPUT -p UDP -i \$LOCAL_IFACE --source-port 68 --destination-port 67 \\
     -j ACCEPT
"
			: '';
	}
?>

# Règles pour les paquets Internet entrants

# Accepter les connexions établies
$IPT -A INPUT -p ALL -i $INET_IFACE -m state --state ESTABLISHED,RELATED \
     -j ACCEPT

<?php
	// allow own IP/CIDR through
print ( $SELF_IN )
	? "
# Autoriser soi à travers (une adresse IP statique / CIDR est le meilleur)
# Comme fourni, cette règle permet l'accès à tous les ports à $\MY_CIDR
# Pour affiner l'accès autorisé, commente cette règle et décommentez la règle
# de tcp_inbound
\$IPT -A INPUT -p TCP -s \$MY_CIDR   -j ACCEPT
"
	: '';

print ( $DICT )
	? "
# Arrêtez les attaques par dictionnaire:
# Cela arrête les taux de raccordement NOUVELLES dépassant 3/minute par IP
# (En plus, une période de calme de 60 sec alors nécessaire)
# Les ports utilisés doivent être identiques dans tous les 4 lignes ci-dessous
# See: https://www.frozentux.net/iptables-tutorial/iptables-tutorial.html#RECENTMATCH
# See: http://forums.modem-help.co.uk/viewtopic.php?t=11438
\$IPT -A INPUT -p TCP -m tcp -m multiport --destination-ports 20,21,25,110,143 \
     -m state --state NEW -m recent --update \
     --seconds 60 --hitcount 4 --rttl -j DROP
\$IPT -A INPUT -p TCP -m tcp -m multiport --destination-ports 20,21,25,110,143 \
     -m state --state NEW -m recent --update \
     --seconds 60 --hitcount 3 --rttl -j LOG \
    --log-prefix \"Dictionary attack: \"
\$IPT -A INPUT -p TCP -m tcp -m multiport --destination-ports 20,21,25,110,143 \
     -m state --state NEW -m recent --update \
     --seconds 60 --hitcount 3 --rttl -j DROP
\$IPT -A INPUT -p TCP -m tcp -m multiport --destination-ports 20,21,25,110,143 \
     -m state --state NEW -m recent --set
"
	: '';
?>

# Router le reste vers la chaîne utilisateur appropriée
$IPT -A INPUT -p TCP -i $INET_IFACE -j tcp_inbound
$IPT -A INPUT -p UDP -i $INET_IFACE -j udp_inbound
$IPT -A INPUT -p ICMP -i $INET_IFACE -j icmp_packets

# Abandonner sans journaliser les diffusionsons qui sont arrivées si loin.
# Diminue l'encombrement du journal. Commentez cette ligne si
# vous essayez de nouvelles règles qui impliquent les protocoles de diffusion.
$IPT -A INPUT -m pkttype --pkt-type broadcast -j DROP

# Journaliser les paquets qui ne correspondent toujours pas
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "
\$IPT -A INPUT -j LOG --log-prefix \"fp=INPUT:99 a=DROP \"
"
		: "
\$IPT -A INPUT -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"INPUT packet died: \"
";
?>

###############################################################################
#
# chaîne FORWARD
#

echo "Traitement de la chaîne FORWARD ..."

# Utilisé si redirection pour un réseau privé

<?php
	if( $GATEWAY ) {
		// private network exists
		print "
# Abandonner les mauvais paquets
\$IPT -A FORWARD -p ALL -j bad_packets

# Accepter les paquets TCP que nous voulons rediriger à partir de sources internes
\$IPT -A FORWARD -p tcp -i \$LOCAL_IFACE -j tcp_outbound

# Accepter les paquets UDP que nous voulons rediriger à partir de sources internes
\$IPT -A FORWARD -p udp -i \$LOCAL_IFACE -j udp_outbound

# Si ce n'est pas bloqué, accepter tous les autres paquets de l'interface interne
\$IPT -A FORWARD -p ALL -i \$LOCAL_IFACE -j ACCEPT

# Traiter les réponses de l'Internet
\$IPT -A FORWARD -i \$INET_IFACE -m state --state ESTABLISHED,RELATED \\
     -j ACCEPT

";

		// If port forwarding option selected, the forward chain must also
		// accept the port forwarding.
		// one/both of PORT_FORWARD_TCP and/or PORT_FORWARD_UDP *must* be selected
		print ( $PORT_FORWARD and $PORT_FORWARD_UDP )
			? "
# La redirection de ports est activée, donc accepter le trafic redirigé
\$IPT -A FORWARD -p udp -i \$INET_IFACE --destination-port ".		(
				(( empty( $PORT_FORWARD_IPORT ))
					? ( $PORT_FORWARD_FROM . (( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO"))
					: $PORT_FORWARD_IPORT
				) ." \\\n     --destination $PORT_FORWARD_IP -j ACCEPT\n\n"
			)
			: '';

		print ( $PORT_FORWARD and $PORT_FORWARD_TCP )
			? "
\$IPT -A FORWARD -p tcp -i \$INET_IFACE --destination-port ".
			(
				(( empty( $PORT_FORWARD_IPORT ))
					? ( $PORT_FORWARD_FROM . (( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO"))
					: $PORT_FORWARD_IPORT
				) ." \\\n     --destination $PORT_FORWARD_IP -j ACCEPT\n\n"
			)
			: '';

		print "# Journaliser les paquets qui ne correspondent toujours pas";

		// Check LOG_FIREPARSE to determine log-prefix format
		print ( $LOG_FIREPARSE )
			? "
\$IPT -A FORWARD -j LOG --log-prefix \"fp=FORWARD:99 a=DROP \"
"
			: "
\$IPT -A FORWARD -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"FORWARD packet died: \"
";
	}
?>

###############################################################################
#
# Chaîne OUTPUT
#

echo "Traitement de la chaîne OUTPUT ..."

# Généralement faire confiance au pare-feu en sortie

# Cependant, les paquets ICMP invalides doivent être abandonnées
# pour éviter une possible attaque.
$IPT -A OUTPUT -m state -p icmp --state INVALID -j DROP

# Localhost
$IPT -A OUTPUT -p ALL -s $LO_IP -j ACCEPT
$IPT -A OUTPUT -p ALL -o $LO_IFACE -j ACCEPT

<?php
	// If private network exists
	print ( $GATEWAY )
		? "
# Vers le réseau interne
\$IPT -A OUTPUT -p ALL -s \$LOCAL_IP -j ACCEPT
\$IPT -A OUTPUT -p ALL -o \$LOCAL_IFACE -j ACCEPT

"
		: '';
?>
# Vers Internet
$IPT -A OUTPUT -p ALL -o $INET_IFACE -j ACCEPT

# Journaliser les paquets qui ne correspondent toujours pas
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "\$IPT -A OUTPUT -j LOG --log-prefix \"fp=OUTPUT:99 a=DROP \""
		: "\$IPT -A OUTPUT -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"OUTPUT packet died: \"";
?>


###############################################################################
#
# Table NAT
#
###############################################################################

# La table NAT est où la traduction d'adresses de réseau se produit
# s'il y a un réseau privé. Si la passerelle est connectée à l'Internet
# avec une adresse IP statique, SNAT est utilisé. Si la passerelle a
# une adresse dynamique, MASQUERADE doit être utilisé à la place.
# Il y a plus de surcharge (CPU) avec MASQUERADE, il vaut donc mieux utiliser SNAT
# quand c'est possible. La table NAT a une chaîne pré-définie, PREROUTING,
# pour DNAT et les redirections. Un autre, POSTROUTING, gère SNAT et MASQUERADE.

echo "Chargement des règles pour la table NAT ..."

###############################################################################
#
# chaîne PREROUTING
#
<?php
	if( $PORT_FORWARD ) {
		// port forwarding option selected, build the rule here
		print "
# Redirection de ports

# La redirection de ports redirige tout le trafic sur un ou plusieurs ports
# du pare-feu à un ordinateur sur le réseau local interne. Cela peut être
# nécessaire pour supporter des situations particulières. Par exemple,
# c'est le seul moyen de soutenir les transferts de fichiers avec un
# client ICQ sur un ordinateur interne. C'est également nécessaire si
# un système interne héberge un service comme un serveur web. Cependant,
# c'est également une option dangereuse. Elle autorise aux ordinateurs
# d'Internet l'accès à votre réseau interne. Utilisez-la avec précaution
# et seulement si vous êtes certain que vous savez ce que vous faîtes.
";

		print ( $PORT_FORWARD_UDP )
			? "
\$IPT -t nat -A PREROUTING -p udp -i \$INET_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_TCP )
			? "
\$IPT -t nat -A PREROUTING -p tcp -i \$INET_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_REDIR and $PORT_FORWARD_UDP )
			? "
\$IPT -t nat -A PREROUTING -p udp -i \$LOCAL_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     --destination \$INET_ADDRESS -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_REDIR and $PORT_FORWARD_TCP )
			? "
\$IPT -t nat -A PREROUTING -p tcp -i \$LOCAL_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     --destination \$INET_ADDRESS -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		// If TRANSPARENT_PROXY option set, redirect port 80 and port 443 to the
		// REDIRECT_PORT on the gateway machine
		print ( $TRANSPARENT_PROXY )
			? "
# Ceci est un exemple qui propose d'exempter un hôte spécifique du proxy transparent
#\$IPT -t nat -A PREROUTING -p tcp -s 192.168.1.50 --destination-port 80 \\
#     -j RETURN
#\$IPT -t nat -A PREROUTING -p tcp -s 192.168.1.50 --destination-port 443 \\
#     -j RETURN

# Rediriger HTTP vers un proxy transparent
\$IPT -t nat -A PREROUTING -p tcp --destination-port 80 \\
     -j REDIRECT --to-ports $REDIRECT_PORT

# Rediriger HTTPS vers un proxy transparent - commentée par défaut
# \$IPT -t nat -A PREROUTING -p tcp --destination-port 443 \\
#     -j REDIRECT --to-ports $REDIRECT_PORT
"
			: '';
	}

	// For devices hosting both Web- and Mail-Servers on same IP
	print ( $BRAINDEAD )
			? "
# Rediriger SMTP Braindead accès de GoogleBot IP vers Internet
# Remarque: httpd conf doit également adapté redirections 301 sur les noms d'hôte de messagerie
# See: http://forums.modem-help.co.uk/viewtopic.php?t=11680
# 2014-03-29 c'est le CIDR Googlebot actuelle: 66.249.64.0/19
$IPT -t nat -A PREROUTING -p tcp -s 66.249.64.0/19 \
     -m multiport --destination-port 25,110,143,995,993 -j LOG \
    --log-prefix \"BrainDead Google redirect: \"
$IPT -t nat -A PREROUTING -p tcp -s 66.249.64.0/19 \
  -m multiport --destination-port 25,110,143,995,993 -j REDIRECT --to-ports 80
"
			: '';
?>

###############################################################################
#
# Chaîne POSTROUTING
#

<?php
	//If it's a gateway then install either snat or masquerade.
	print ( $GATEWAY )
		? (( $DYNAMIC_IP )	// masquerade or snat
			? "\$IPT -t nat -A POSTROUTING -o \$INET_IFACE -j MASQUERADE\n"
			: "\$IPT -t nat -A POSTROUTING -o \$INET_IFACE \\
     -j SNAT --to-source \$INET_ADDRESS\n".
			(( $PORT_FORWARD_REDIR )
				? "\$IPT -t nat -A POSTROUTING -o \$LOCAL_IFACE \\
     -j SNAT --to-source \$INET_ADDRESS
"
				: ''
			)
		)
		: '';
?>

###############################################################################
#
# Table 'mangle'
#
###############################################################################

# La table 'mangle' est utilisée pour modifier les paquets.
# Elle peut modifier ou manipuler ceux-ci de plusieurs façons. Pour
# l'application à ce générateur, on utilise seulement la capacité
# de modifier la valeur TTL dans les paquets. Cependant, il
# peut être utilisé pour définir les marquages Netfilter
# sur des paquets spécifiques. Ces marques peuvent ensuite être
# utilisées dans une autre table comme 'filter', afin de limiter
# les activités associées à un hôte spécifique, par exemple. La cible
# TOS peut être utilisé pour définir le champ Type de Service dans
# l'en-tête IP. Notez que la cible TTL pourrait ne pas être incluse
# dans la distribution sur votre système. Si elle n'est pas et si
# vous avez besoin, vous devrez l'ajouter. Cela peut exiger que vous
# construisiez à partir des sources.

echo "Chargement des règles pour la table 'mangle' ..."
<?php
	// Reset the TTL if requested to do so.
	print ( $MANGLE_TTL )
		? "
# Définir la durée de vie dans les paquets sortants à la même valeur
# constante. Une valeur autour de 128 est une bonne valeur. Ne pas
# fixer une valeur trop élevée car elle porrait nuire à votre réseau.
# C'est également considéré comme une malformé sur Internet.
\$IPT -t mangle -A OUTPUT -o \$INET_IFACE -j TTL --ttl-set $TTL
"
		: '';
// vi: shiftwidth=3 tabstop=3 et
?>
